load 20180502_115539_v1.mat %Baseline

close all;

fSize =20;
fName = 'Helvetica'; 

%colormap(lines(5));
Cmap =[0    0.4470    0.7410;0.8500    0.3250    0.0980;0.9290    0.6940    0.1250;0.4940    0.1840    0.5560;0.4660    0.6740    0.1880];
%Cmap = [0 165 255;255 144 0;155 155 155;255 212 0;0 100 255]/255;
C1 = Cmap(1,:);
C2 = Cmap(2,:);
C3 = Cmap(3,:);
C4 = Cmap(4,:);
C5 = Cmap(5,:);

FrailtyTick = 1:1:5;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
figure
axes('FontSize',fSize,'FontName',fName,...
     'XTick',FrailtyTick,...
     'XGrid','off','YGrid','off');
box off
hold on;

p1=plot(NHentrybyyhq_h,'LineWidth',2);

set(p1(1),'Color',C1,'Marker','diamond','MarkerSize',8,'MarkerFaceColor',C1)
set(p1(2),'Color',C2,'Marker','o','MarkerSize',8,'MarkerFaceColor',C2)
set(p1(3),'Color',C3,'Marker','square','MarkerSize',8,'MarkerFaceColor',C3)
set(p1(4),'Color',C4,'Marker','^','MarkerSize',8,'MarkerFaceColor',C4)
set(p1(5),'Color',C5,'Marker','x','MarkerSize',12,'MarkerFaceColor',C5)

hold on;
p2=plot(NHentrybyyhq_l,'LineWidth',2);

set(p2(1),'Color',C1,'Marker','diamond','MarkerSize',8,'MarkerFaceColor',C1)
set(p2(2),'Color',C2,'Marker','o','MarkerSize',8,'MarkerFaceColor',C2)
set(p2(3),'Color',C3,'Marker','square','MarkerSize',8,'MarkerFaceColor',C3)
set(p2(4),'Color',C4,'Marker','^','MarkerSize',8,'MarkerFaceColor',C4)
set(p2(5),'Color',C5,'Marker','x','MarkerSize',12,'MarkerFaceColor',C5)
ylim([0 1])
xlabel('Frailty quintile')
ylabel('NH entry probability');

%hold on;
%plot(NHentry_byyhq_means);
%xlabel('Frailty quintile','FontSize',14,'FontName','FixedWidth','FontName','Arial');
legend(p1,{'PE quintile 1','PE quintile 2','PE quintile 3','PE quintile 4','PE quintile 5'},'location','NorthEast','orientation','vertical');
legend boxoff

set(gcf,'PaperPositionMode','auto');
set(gcf,'PaperUnits','inches')
set(gcf,'PaperSize',[8.1,6])
set(gcf,'PaperPosition',[0.0,0.0,8,6])
set(gca,'LooseInset',get(gca,'TightInset'))
print(gcf,'-dpdf','NHentryUnCond.pdf')

%print(gcf, 'NHentry1.pdf', '-dpdf', '-r1200', '-noui')
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
figure
axes('FontSize',fSize,'FontName',fName,...
     'XTick',FrailtyTick,...
     'XGrid','off','YGrid','off');
box off
hold on;
p1=plot(NHentrysurvsbyyhq_h,'LineWidth',2);

set(p1(1),'Color',C1,'Marker','diamond','MarkerSize',8,'MarkerFaceColor',C1)
set(p1(2),'Color',C2,'Marker','o','MarkerSize',8,'MarkerFaceColor',C2)
set(p1(3),'Color',C3,'Marker','square','MarkerSize',8,'MarkerFaceColor',C3)
set(p1(4),'Color',C4,'Marker','^','MarkerSize',8,'MarkerFaceColor',C4)
set(p1(5),'Color',C5,'Marker','x','MarkerSize',10,'MarkerFaceColor',C5)


hold on;
p2=plot(NHentrysurvsbyyhq_l,'LineWidth',2);

set(p2(1),'Color',C1,'Marker','diamond','MarkerSize',8,'MarkerFaceColor',C1)
set(p2(2),'Color',C2,'Marker','o','MarkerSize',8,'MarkerFaceColor',C2)
set(p2(3),'Color',C3,'Marker','square','MarkerSize',8,'MarkerFaceColor',C3)
set(p2(4),'Color',C4,'Marker','^','MarkerSize',8,'MarkerFaceColor',C4)
set(p2(5),'Color',C5,'Marker','x','MarkerSize',10,'MarkerFaceColor',C5)


xlabel('Frailty quintile')
ylabel('NH entry probability');
ylim([0 1])

legend(p1,{'PE quintile 1','PE quintile 2','PE quintile 3','PE quintile 4','PE quintile 5'},'Position',[0.38,0.06, 1, 1],'units','normalized');
legend boxoff

text(1.1,0.92,'bad types','HorizontalAlignment','left','FontSize',fSize)
text(1.1,0.15,'good types','HorizontalAlignment','left','FontSize',fSize)


set(gcf,'PaperPositionMode','auto');
set(gcf,'PaperUnits','inches')
set(gcf,'PaperSize',[8.1,6])
set(gcf,'PaperPosition',[0.0,0.0,8,6])
set(gca,'LooseInset',get(gca,'TightInset'))
print(gcf,'-dpdf','NHentrySurvs.pdf')

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
figure

axes('FontSize',fSize,'FontName',fName,...
     'XTick',FrailtyTick,...
     'XGrid','off','YGrid','off');
box off
hold on;
p1=plot(FracSurvsEnterNHbyyhq,'LineWidth',2);

set(p1(1),'Color',C1,'Marker','diamond','MarkerSize',8,'MarkerFaceColor',C1)
set(p1(2),'Color',C2,'Marker','o','MarkerSize',8,'MarkerFaceColor',C2)
set(p1(3),'Color',C3,'Marker','square','MarkerSize',8,'MarkerFaceColor',C3)
set(p1(4),'Color',C4,'Marker','^','MarkerSize',8,'MarkerFaceColor',C4)
set(p1(5),'Color',C5,'Marker','x','MarkerSize',10,'MarkerFaceColor',C5)

xlabel('Frailty quintile')
ylabel('NH entry probability');
ylim([0.25 0.55])

legend(p1,{'PE quintile 1','PE quintile 2','PE quintile 3','PE quintile 4','PE quintile 5'},'location','SouthEast','orientation','vertical');
%legend(p1,{'PE quintile 1','PE quintile 2','PE quintile 3','PE quintile 4','PE quintile 5'},'Position',[0.38,0.06, 1, 1],'units','normalized');
legend boxoff

set(gcf,'PaperPositionMode','auto');
set(gcf,'PaperUnits','inches')
set(gcf,'PaperSize',[8.1,6])
set(gcf,'PaperPosition',[0.0,0.0,8,6])
set(gca,'LooseInset',get(gca,'TightInset'))
print(gcf,'-dpdf','Fig_NH_entry_prob_survs.pdf')

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
figure

axes('FontSize',fSize,'FontName',fName,...
     'XTick',FrailtyTick,...
     'XGrid','off','YGrid','off');
box off
hold on;
p1=plot(NHentrybyyhq,'LineWidth',2);

set(p1(1),'Color',C1,'Marker','diamond','MarkerSize',8,'MarkerFaceColor',C1)
set(p1(2),'Color',C2,'Marker','o','MarkerSize',8,'MarkerFaceColor',C2)
set(p1(3),'Color',C3,'Marker','square','MarkerSize',8,'MarkerFaceColor',C3)
set(p1(4),'Color',C4,'Marker','^','MarkerSize',8,'MarkerFaceColor',C4)
set(p1(5),'Color',C5,'Marker','x','MarkerSize',10,'MarkerFaceColor',C5)

xlabel('Frailty quintile')
ylabel('NH entry probability');
ylim([0.25 0.4])

legend(p1,{'PE quintile 1','PE quintile 2','PE quintile 3','PE quintile 4','PE quintile 5'},'location','NorthEast','orientation','vertical');
%legend(p1,{'PE quintile 1','PE quintile 2','PE quintile 3','PE quintile 4','PE quintile 5'},'Position',[0.38,0.06, 1, 1],'units','normalized');
legend boxoff

set(gcf,'PaperPositionMode','auto');
set(gcf,'PaperUnits','inches')
set(gcf,'PaperSize',[8.1,6])
set(gcf,'PaperPosition',[0.0,0.0,8,6])
set(gca,'LooseInset',get(gca,'TightInset'))
print(gcf,'-dpdf','Fig_NH_entry_prob_uncond.pdf')


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


LTCIratesData = [0.011  0.060  0.097 0.147 0.233; ...
                 0.021	0.047	0.104	0.158	0.205; ...
                 0.021	0.029  0.086	0.131	0.200; ...
                 0.015	0.032	0.068	0.113	0.157; ... 
                 0.015	0.028	0.050	0.107	0.104];

figure

axes('FontSize',fSize,'FontName',fName,...
     'XTick',FrailtyTick,...
     'XGrid','off','YGrid','off');
box off
hold on;
p1=plot(LTCIratesData,'LineWidth',2);

set(p1(1),'Color',C1,'Marker','diamond','MarkerSize',8,'MarkerFaceColor',C1)
set(p1(2),'Color',C2,'Marker','o','MarkerSize',8,'MarkerFaceColor',C2)
set(p1(3),'Color',C3,'Marker','square','MarkerSize',8,'MarkerFaceColor',C3)
set(p1(4),'Color',C4,'Marker','^','MarkerSize',8,'MarkerFaceColor',C4)
set(p1(5),'Color',C5,'Marker','x','MarkerSize',10,'MarkerFaceColor',C5)

xlabel('Frailty quintile')
ylabel('LTCI take-up rate');
ylim([0.0 0.3])

legend(p1,{'wealth quintile 1','wealth quintile 2','wealth quintile 3','wealth quintile 4','wealth quintile 5'},'location','NorthEast','orientation','vertical');
%legend(p1,{'PE quintile 1','PE quintile 2','PE quintile 3','PE quintile 4','PE quintile 5'},'Position',[0.38,0.06, 1, 1],'units','normalized');
legend boxoff

set(gcf,'PaperPositionMode','auto');
set(gcf,'PaperUnits','inches')
set(gcf,'PaperSize',[8.1,6])
set(gcf,'PaperPosition',[0.0,0.0,8,6])
set(gca,'LooseInset',get(gca,'TightInset'))
print(gcf,'-dpdf','LTCItakeupratesData.pdf')

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%



SurvsProbsData = zeros(5,5);
SurvsProbsData(1,:) = survprobslmat(1,:);
SurvsProbsData(2,:) = survprobslmat(50,:);
SurvsProbsData(3,:) = survprobslmat(90,:);
SurvsProbsData(4,:) = survprobslmat(91,:);
SurvsProbsData(5,:) = survprobslmat(150,:);
SurvsProbsData = SurvsProbsData';

figure

axes('FontSize',fSize,'FontName',fName,...
     'XTick',FrailtyTick,...
     'XGrid','off','YGrid','off');
box off
hold on;
p1=plot(SurvsProbsData,'LineWidth',2);

set(p1(1),'Color',C1,'Marker','diamond','MarkerSize',8,'MarkerFaceColor',C1)
set(p1(2),'Color',C2,'Marker','o','MarkerSize',8,'MarkerFaceColor',C2)
set(p1(3),'Color',C3,'Marker','square','MarkerSize',8,'MarkerFaceColor',C3)
set(p1(4),'Color',C4,'Marker','^','MarkerSize',8,'MarkerFaceColor',C4)
set(p1(5),'Color',C5,'Marker','x','MarkerSize',10,'MarkerFaceColor',C5)

xlabel('Frailty quintile')
ylabel('Survival probability');
ylim([0.55 1])

legend(p1,{'PE quintile 1','PE quintile 2','PE quintile 3','PE quintile 4','PE quintile 5'},'location','NorthEast','orientation','vertical');
%legend(p1,{'PE quintile 1','PE quintile 2','PE quintile 3','PE quintile 4','PE quintile 5'},'Position',[0.38,0.06, 1, 1],'units','normalized');
legend boxoff

set(gcf,'PaperPositionMode','auto');
set(gcf,'PaperUnits','inches')
set(gcf,'PaperSize',[8.1,6])
set(gcf,'PaperPosition',[0.0,0.0,8,6])
set(gca,'LooseInset',get(gca,'TightInset'))
print(gcf,'-dpdf','fig_survival_probs.pdf')

