%OnlylMTSI

TolF = 1.e-12;
%TolF = 1.e-4;
MaxEvals = 300;

nc = 3; %number of cases computed
npc = 1; %number of pooling cases computed  

csvect = zeros(1,nc);
casefailedvect = zeros(1,nc);

%x's are the benefits, t's are the premiums
xlvect = zeros(1,nc);
xhvect = zeros(1,nc);
tlvect = zeros(1,nc);
thvect = zeros(1,nc);
profitsvect = zeros(1,nc);

xpvect = zeros(1,npc);
tpvect = zeros(1,npc);
profitspvect = zeros(1,npc);

solmat = zeros(4,nc);
solpmat = zeros(4,npc);

nbcmat = zeros(4,nc);
nbcpmat = zeros(3,npc);



    
%% monopolist and private information


%%
%case 1:
% (PC2)_h holds with equality 
caseno = 1;

% xh th lambdaP 
%ing = [l 0.9*l 0 0];
xhg = l+chat;
thg = min( [((1+r)*as+(1-tau)*wo+ls-r*as*tau- kappavect(nk)*wy)*0.75, ((1+r)*as+(1-tau)*wo+ls-r*as*tau-l+xhg- kappavect(nk)*wy)*0.75, 0.9*xhg ]);
ing = zeros(1,4);
ing(1) = log((1+r)*as-thg-l+xhg+(1-tau)*wo+ls-r*as*tau- kappavect(1)*wy-chat); %chl
ing(2) = log((1+r)*as-thg+(1-tau)*wo+ls-r*as*tau- kappavect(nk)*wy); %ch

focshonly_1 = @(x) focshonly(x, alpha_vect, sigma, r, chat, l, wo, wy, tau, phi, thetal_vect, thetah_vect, survprobl, survprobh,...
    as, caseno, cmin, lambda, ls, nk, kappavect, distkappa, udeath, udeathprime);

solmat(:,caseno) = fsolve(focshonly_1,ing, optimset('MaxFunEvals', MaxEvals,'TolFun',TolF,'display','off'));
[nbcmat(:,caseno), fval] =  focshonly_fake(solmat(:,caseno), alpha_vect, sigma, r, chat, l, wo, wy, tau, phi, thetal_vect, thetah_vect, survprobl, survprobh,...
    as, caseno, cmin, lambda, ls, nk, kappavect, distkappa, udeath, udeathprime);
fnorm = norm(fval);
if fnorm > TolF*10;
    %fprintf(1,'Uh0nly focshonly case %g failed: fnorm = %4.2e\n',caseno,fnorm);
    casefailedvect(caseno) = 1;
end

%ch is for kappvect(nk) and chl is for kappavect(1)
chl = exp(solmat(1,caseno))+chat;
ch = exp(solmat(2,caseno));
xhvect(caseno) = chl-  (ch + (kappavect(nk) - kappavect(1))*wy) +l; 
thvect(caseno) = (1+r)*as+(1-tau)*wo+ls -r*as*tau -kappavect(nk)*wy- ch;  
xlvect(caseno) = 0;
tlvect(caseno) = 0;

% cll_vect = max((1+r)*as - 0 - l +0+(1-tau)*wo +ls -r*as*tau -kappavect.*wy, cmin);
% chl_vect = max((1+r)*as - thvect(caseno)- l + xhvect(caseno)+(1-tau)*wo +ls -r*as*tau - kappavect.*wy, cmin);
% cl_vect = max(cmin2,(1+r)*as - 0+(1-tau)*wo +ls -r*as*tau - kappavect.*wy);
% ch_vect = max(cmin2,(1+r)*as - thvect(caseno)+(1-tau)*wo +ls -r*as*tau - kappavect.*wy);
% [nbcvect2, out2] = focs_fake2([log(chl_vect(50)) log(ch_vect(nk))], 50, cll_vect, cl_vect, alpha_vect, sigma, r, l, chat, 0, wo, wy, tau, 0, thetal_vect, thetah_vect, survprobl, survprobh, ...
%     as, cmin, cmin2, lambda, assumexhl, ls, nk, kappavect, distkappa, 0, 0)

csvect(caseno) = sum(nbcmat(:,caseno)<-TolF*10);

if (xhvect(caseno) < 0)
    casefailedvect(caseno) = 1;
end

if casefailedvect(caseno) == 0 && csvect(caseno) == 0
   profitsvect(caseno) = phi*(tlvect(caseno) -  survprobl.*sum( thetal_vect.*distkappa) .* ( lambda.*xlvect(caseno) + k*(xlvect(caseno)>0)) ) + ...
                             (1-phi)*(thvect(caseno) - survprobh.*sum( thetah_vect.*distkappa) .* ( lambda*xhvect(caseno)+k*(xhvect(caseno)>0)) );
 else
   profitsvect(caseno) = -inf;
end
%keyboard

%% monopolist and full information    
if soltype == 2
    
    %(PC_h) holds this is caseno=1 above
    xlmax = xlvect(caseno);
    tlmax = tlvect(caseno);
    xhmax = xhvect(caseno);
    thmax = thvect(caseno);
    
    if casefailedvect(caseno) == 0 
       profitsmax = phi*(tlvect(caseno) -  survprobl.*sum( thetal_vect.*distkappa) .* ( lambda.*xlvect(caseno) + k*(xlvect(caseno)>0)) ) + ...
                             (1-phi)*(thvect(caseno) - survprobh.*sum( thetah_vect.*distkappa) .* ( lambda*xhvect(caseno)+k*(xhvect(caseno)>0)) );
    else
       profitsmax = -inf;
    end
    
    if (profitsmax == -inf)
        fprintf('No solution soltype 2, case with OnlylMTSI\n');
        profitsmax = 0;
        xlmax = 0;
        tlmax = 0;
        xhmax = 0;
        thmax = 0;
    end    
    
    if profitsmax < 0|| xhmax < 0 || thmax < 0 
        tlmax = 0;
        xlmax = 0;
        thmax = 0;
        xhmax = 0;
        profitsmax = 0;
    end 
    out = profitsmax;
    pnind = 0;
    
    return
    
end

%%
%case 2:
% (IC2)_l holds with equality 
caseno = 2;

% xh th lambdaP lambdaI
%ing = [l 0.9*l 0 0];
xhg = l+chat;
thg = min( [((1+r)*as+(1-tau)*wo+ls-r*as*tau- kappavect(nk).*wy)*0.75, ((1+r)*as+(1-tau)*wo+ls-r*as*tau-l+xhg- kappavect(nk).*wy)*0.75, 0.9*xhg ]);
ing = zeros(1,4);
ing(1) = log((1+r)*as-thg-l+xhg+(1-tau)*wo+ls-r*as*tau- kappavect(1).*wy-chat); %chl
ing(2) = log((1+r)*as-thg+(1-tau)*wo+ls-r*as*tau- kappavect(nk).*wy); %ch

focshonly_1 = @(x) focshonly(x, alpha_vect, sigma, r, chat, l, wo, wy, tau, phi, thetal_vect, thetah_vect, survprobl, survprobh,...
    as, caseno, cmin, lambda, ls, nk, kappavect, distkappa, udeath, udeathprime);
solmat(:,caseno) = fsolve(focshonly_1,ing, optimset('MaxFunEvals', MaxEvals,'TolFun',TolF,'display','off'));
[nbcmat(:,caseno), fval] =  focshonly_fake(solmat(:,caseno), alpha_vect, sigma, r, chat, l, wo, wy, tau, phi, thetal_vect, thetah_vect, survprobl, survprobh,...
    as, caseno, cmin, lambda, ls, nk, kappavect, distkappa, udeath, udeathprime);
fnorm = norm(fval);
if fnorm > TolF*10
    %fprintf(1,'Uh0nly focshonly case %g failed: fnorm = %4.2e\n',caseno,fnorm);
    casefailedvect(caseno) = 1;
end 
%chl is kappavect(1) and ch is kappavect(nk)
chl = exp(solmat(1,caseno))+chat;
ch = exp(solmat(2,caseno));
xhvect(caseno) = chl-  (ch + (kappavect(nk) - kappavect(1))*wy) +l; 
thvect(caseno) = (1+r)*as+(1-tau)*wo+ls -r*as*tau  -kappavect(nk)*wy - ch;  
xlvect(caseno) = 0;
tlvect(caseno) = 0;  


if (xhvect(caseno) < 0)
    casefailedvect(caseno) = 1;
end

csvect(caseno) = sum(nbcmat(:,caseno)<-1.0e-6);



if casefailedvect(caseno) == 0 && csvect(caseno) == 0
   profitsvect(caseno) = phi*(tlvect(caseno) -  survprobl.*sum( thetal_vect.*distkappa) .* ( lambda.*xlvect(caseno) + k*(xlvect(caseno)>0)) ) + ...
                             (1-phi)*(thvect(caseno) - survprobh.*sum( thetah_vect.*distkappa) .* ( lambda*xhvect(caseno)+k*(xhvect(caseno)>0)) );
else
   profitsvect(caseno) = -inf;
end
%keyboard
%%
%case 3:
% (PC2_h) and (IC2)_l holds with equality 
caseno = 3;

% xh th lambdaP lambdaI
%ing = [l 0.9*l 0 0];
xhg = l+chat;
thg = min( [((1+r)*as+(1-tau)*wo+ls-r*as*tau- kappavect(nk).*wy)*0.75, ((1+r)*as+(1-tau)*wo+ls-r*as*tau-l+xhg- kappavect(nk).*wy)*0.75, 0.9*xhg ]);
ing = zeros(1,4);
ing(1) = log((1+r)*as-thg-l+xhg+(1-tau)*wo+ls-r*as*tau - kappavect(1).*wy-chat); %chl
ing(2) = log((1+r)*as-thg+(1-tau)*wo+ls-r*as*tau - kappavect(nk).*wy); %ch

focshonly_1 = @(x) focshonly(x, alpha_vect, sigma, r, chat, l, wo, wy, tau, phi, thetal_vect, thetah_vect, survprobl, survprobh,...
    as, caseno, cmin, lambda, ls, nk, kappavect, distkappa, udeath, udeathprime);
solmat(:,caseno) = fsolve(focshonly_1,ing, optimset('MaxFunEvals', MaxEvals,'TolFun',TolF,'display','off'));
[nbcmat(:,caseno), fval] =  focshonly_fake(solmat(:,caseno), alpha_vect, sigma, r, chat, l, wo, wy, tau, phi, thetal_vect, thetah_vect, survprobl, survprobh,...
    as, caseno, cmin, lambda, ls, nk, kappavect, distkappa, udeath, udeathprime);
fnorm = norm(fval);
if fnorm > TolF*10
    %fprintf(1,'Uh0nly focshonly case %g failed: fnorm = %4.2e\n',caseno,fnorm);
    casefailedvect(caseno) = 1;
end 
%ch is for kappavect(nk) and chl is for kappavect(1)
chl = exp(solmat(1,caseno))+chat;
ch = exp(solmat(2,caseno));
xhvect(caseno) = chl-  (ch + (kappavect(nk) - kappavect(1))*wy) +l; 
thvect(caseno) = (1+r)*as+(1-tau)*wo+ls -r*as*tau -kappavect(nk)*wy - ch;  
xlvect(caseno) = 0;
tlvect(caseno) = 0;   


if (xhvect(caseno) < 0)
    casefailedvect(caseno) = 1;
end

csvect(caseno) = sum(nbcmat(:,caseno)<-TolF*10);


if casefailedvect(caseno) == 0 && csvect(caseno) == 0
   profitsvect(caseno) = phi*(tlvect(caseno) -  survprobl.*sum( thetal_vect.*distkappa) .* ( lambda.*xlvect(caseno) + k*(xlvect(caseno)>0)) ) + ...
                             (1-phi)*(thvect(caseno) - survprobh.*sum( thetah_vect.*distkappa) .* ( lambda*xhvect(caseno)+k*(xhvect(caseno)>0)) );
else
   profitsvect(caseno) = -inf;
end
%keyboard
%%
%case p4:
% (PC2)_l, (PC2)_h hold with equality 
caseno = 1;      
xpvect(caseno) = 0;
tpvect(caseno) = 0;         
profitspvect(caseno) = 0;    

%%
%determine optimal contract

[profitsmaxp , casepmax] = max(profitspvect);

xlmaxp  = xpvect(casepmax);
xhmaxp  = xpvect(casepmax);
tlmaxp  = tpvect(casepmax);
thmaxp  = tpvect(casepmax); 

[profitsmaxr , casemax] = max(profitsvect);

xlmaxr  = xlvect(casemax);
xhmaxr  = xhvect(casemax);
tlmaxr  = tlvect(casemax);
thmaxr  = thvect(casemax);    


pnind  = profitsmaxp -profitsmaxr  > -1e-6;
if  pnind  ==1

    xlmax  = xlmaxp ;
    xhmax  = xhmaxp ;
    tlmax  = tlmaxp ;
    thmax  = thmaxp ;
    profitsmax  =profitsmaxp ; 

else
    xlmax  = xlmaxr ;
    xhmax  = xhmaxr ;
    tlmax  = tlmaxr ;
    thmax  = thmaxr ;
    profitsmax  =profitsmaxr ; 
end

if (profitsmax == -inf)
    fprintf('No solution soltype 1, case with OnlylMTSI\n');
    %keyboard
    tlmax = 0;
    xlmax = 0;
    thmax = 0;
    xhmax = 0;
    profitsmax = 0;
end

if profitsmax < 0
    tlmax = 0;
    xlmax = 0;
    thmax = 0;
    xhmax = 0;
    profitsmax = 0;
end


