
%tbegin = cputime;

tic;

%%

NumMTSIvect = zeros(1,2);
NumWouldMTSIvect = zeros(1,2);
FracLTCIvect = zeros(1,2);
FracSurvsLTCIvect = zeros(1,2);
FracRejectedvect = zeros(1,2);
NumRejectedMTSIvect = zeros(1,2);
NumRejectedNoMTSIvect = zeros(1,2);
NumLTCIandMTSIvect = zeros(1,2);
NumUseLTCIvect = zeros(1,2);
NumNonNHLTCIvect = zeros(1,2);
NumUseLTCIandMTSIvect = zeros(1,2);
NumNHRejectedMTSIvect = zeros(1,2);
NumNHRejectedNoMTSIvect = zeros(1,2);

Aveloadvect = zeros(1,2);
AveFracCovered = zeros(1,2);
benefitcostratio = zeros(1,2);
costspremiaratio = zeros(1,2);
Profitsvect = zeros(1,2);
Utilityvect = zeros(1,2);
RevNetTrs1vect = zeros(1,2);
RevNetTrs2vect = zeros(1,2);
RevNetTrs3vect = zeros(1,2);
ProfitsErrorvect = zeros(1,2);
tau1vect = zeros(1,2);
tau2vect = zeros(1,2);
tau3vect = zeros(1,2);
asmeanvect = zeros(1,2);
postasmeanvect = zeros(1,2);
postasNHmeanvect = zeros(1,2);
MedicaidOutlays = zeros(1,2);
names = cell(1,2);

for soltype =1:Ns %loop over various setups (monopolist with private info., monopolist without private info.)
%for soltype =2:2 %loop over various setups (monopolist with private info., monopolist without private info.)

    
    TotalProfits = profitsg;
    tau1 = taug1;
    tau2 = taug2;
    tau3 = taug3;

    for i=1:Np %loop over profits and tax rate (both get updated in each iteration)

        profitsg = TotalProfits;
        lsmat = profitsg.*alphayh; %lump-sum transfer of profits in period 2

        taug1 = tau1;
        taug2 = tau2;
        taug3 = tau3;

        [U0mat, U1mat, asmat, postaslmat, postashmat, xlsmat, xhsmat, tlsmat, ...
            thsmat, cysmat, chNHsmat, clNHsmat, ch0smat, cl0smat, profitsmat, MTSIh, ...
            MTSIl, optcasemat, poolsolmat, translmat, transhmat, translmat2, transhmat2, translmat21, transhmat21, translmat22, ...
            transhmat22, translmat31, transhmat31, translmat32, transhmat32, Oncfloorsmat] =...
            govtbudget(taug1+taug2+taug3, nk, soltype, sigma, r, l, chat, chat2, thetalmat, thetahmat, survprobslmat, survprobshmat, ...
            beta, alpha_vect, cmin, cmin2, cmin3, lambda, k, distkappa, kappavect, ny, nh, phimat, ymat, yomat, lsmat, distyh, ...
            udeath, udeathprime);
        
       
        TotalProfits = sum(sum( distyh.*profitsmat ));
        fprintf('TotalProfits - profitsg = %g\n',TotalProfits - profitsg)

        TotalTransfers1 = sum(sum( distyh.*(survprobslmat.*phimat.*translmat2+survprobshmat.*(1-phimat).*transhmat2) ));
        TotalRevenue1 = sum(sum( distyh.*tau1.*( (1+r).*ymat + yomat + r.*asmat +lsmat) ));
        TotalTransfers2 = sum(sum( distyh.*(phimat.*translmat22+(1-phimat).*transhmat22) ));
        TotalRevenue2 = sum(sum( distyh.*tau2.*( (1+r).*ymat + yomat + r.*asmat +lsmat) )); 
        TotalTransfers3 = sum(sum( distyh.*(phimat.*translmat32+(1-phimat).*transhmat32) ));
        TotalRevenue3 = sum(sum( distyh.*tau3.*( (1+r).*ymat + yomat + r.*asmat +lsmat) ));         
        TotalTaxIncome = sum(sum( distyh.*( (1+r).*ymat + yomat + r.*asmat +lsmat) ));
        tau1 = TotalTransfers1./TotalTaxIncome;    
        tau2 = TotalTransfers2./TotalTaxIncome; 
        tau3 = TotalTransfers3./TotalTaxIncome; 
        
        fprintf('Govt rev 1 - transfers 1 = %g\n',TotalRevenue1-TotalTransfers1)
        fprintf('tau1 - taug1 = %g\n',tau1-taug1)
        fprintf('Govt rev 2 - transfers 2 = %g\n',TotalRevenue2-TotalTransfers2)
        fprintf('tau2 - taug2 = %g\n',tau2-taug2)    
        fprintf('Govt rev 3 - transfers 3 = %g\n',TotalRevenue3-TotalTransfers3)
        fprintf('tau3 - taug3 = %g\n',tau3-taug3)         
    end
    tau = tau1+tau2+tau3;
    %tlapsed = cputime - tbegin;
    toc; 
    %fprintf(1,'time lapsed = %g \n', tlapsed);
    
%% Output
MTSI2h=zeros(ny,nh,nk);
MTSI2l=zeros(ny,nh,nk);
MTSI2h(transhmat21 > 0) = 1;
MTSI2l(translmat21 > 0) = 1; 

    MedicaidOutlays(soltype) = TotalTransfers1;     
    Profitsvect(soltype) = TotalProfits;
    Utilityvect(soltype) = sum(sum( distyh.*U0mat )); %average or ex ante utility
    RevNetTrs1vect(soltype) = TotalRevenue1-TotalTransfers1;
    RevNetTrs2vect(soltype) = TotalRevenue2-TotalTransfers2;
    RevNetTrs3vect(soltype) = TotalRevenue3-TotalTransfers3;
    ProfitsErrorvect(soltype) = TotalProfits - profitsg;
    tau1vect(soltype) = tau1; 
    tau2vect(soltype) = tau2; 
    tau3vect(soltype) = tau3; 

%% no-trade condition
    ucl0mat = max(cmin,repmat((1+r)*asmat - l+(1-tau)*yomat+lsmat-r*asmat*tau,[1 1 nk]) - ...
        repmat(reshape(kappavect,1,1,nk),ny,nh,1).*repmat(ymat,[1 1 nk])); 
    %ucl0mat(ucl0mat> cmin ) = (ucl0mat(ucl0mat>cmin)-chat).^(-sigma);
    %ucl0mat(ucl0mat==cmin) = 0;
    ucl0mat = (ucl0mat-chat).^(-sigma);    
    uc0mat = max(cmin2,repmat((1+r)*asmat +(1-tau)*yomat+lsmat-r*asmat*tau,[1 1 nk]) - ...
        repmat(reshape(kappavect,1,1,nk),ny,nh,1).*repmat(ymat,[1 1 nk])); 
    uc0mat(uc0mat> cmin2 ) = (uc0mat(uc0mat>cmin2)).^(-sigma);
    uc0mat(uc0mat==cmin2) = 0;
    udeath0mat = uc0mat;
    %uc0mat = uc0mat.^(-sigma);
    %udeath0mat = udeathprime(udeath0mat);
    MRSl0 = sum( repmat(survprobslmat,[1 1 nk]).*repmat(reshape(alpha_vect,1,1,nk),ny,nh,1).*(thetalmat .* ucl0mat ).*distkappamat , 3)./...
        sum(repmat(reshape( alpha_vect,1,1,nk),ny,nh,1).*(repmat(survprobslmat,[1 1 nk]).*(thetalmat .* ucl0mat + (1-thetalmat) .*uc0mat) + ...
        (1-repmat(survprobslmat,[1 1 nk])).*udeath0mat).*distkappamat ,3);
    MRSl0 = squeeze(MRSl0);
    rhsp = lambda*(phimat.*survprobslmat.*sum(thetalmat.*distkappamat,3)+(1-phimat).*survprobshmat.*sum(thetahmat.*distkappamat,3));
    %contracts should be zero if this is positive
    rhsplessMRSl0 = rhsp-MRSl0;
    
    MRSh0 = sum( repmat(survprobshmat,[1 1 nk]).*repmat(reshape(alpha_vect,1,1,nk),ny,nh,1).*(thetahmat .* ucl0mat ).*distkappamat , 3)./...
        sum(repmat(reshape( alpha_vect,1,1,nk),ny,nh,1).*(repmat(survprobshmat,[1 1 nk]).*(thetahmat .* ucl0mat + (1-thetahmat) .*uc0mat) + ...
        (1-repmat(survprobshmat,[1 1 nk])).*udeath0mat).*distkappamat ,3); 
    MRSh0 = squeeze(MRSh0);
    rhsph = lambda*survprobshmat.*sum(thetahmat.*distkappamat,3);
    rhsphlessMRSh0 = rhsph-MRSh0;      
    
 %% insurance usage
    FracOncfloors = sum(sum(Oncfloorsmat.*distyh.*(survprobslmat.*phimat+survprobshmat.*(1-phimat) ) ))/FracSurv;
 
    FracLTCIvect(soltype) = sum(sum(phimat(tlsmat>0).*distyh(tlsmat>0))) + sum(sum((1-phimat(thsmat>0)).*distyh(thsmat>0)));
    FracLTCIbyyh = phimat.*(tlsmat>0) + (1-phimat).*(thsmat>0);
    FracLTCIbyh = sum( FracLTCIbyyh.*distyh ,1)./disth;
    FracLTCIbyy = sum( FracLTCIbyyh.*distyh ,2)'./disty;    
    [FracLTCI_byhq_means,  FracLTCI_byhq_shares] = get_dist_stats_x(FracLTCIbyh, disth, phi_cutoffs, ng);
    [FracLTCI_byyq_means,  FracLTCI_byyq_shares] = get_dist_stats_x(FracLTCIbyy, disty, y_cutoffs, ng);
    FracLTCIl  = sum(sum(distyh.*(tlsmat>0).*phimat))/sum(sum(distyh.*phimat)) ;
    FracLTCIh  = sum(sum(distyh.*(thsmat>0).*(1-phimat)))/sum(sum(distyh.*(1-phimat))) ;
    FracLTCIlbyh  = sum(distyh.*(tlsmat>0).*phimat,1)./sum(distyh.*phimat,1) ;
    FracLTCIhbyh  = sum(distyh.*(thsmat>0).*(1-phimat),1)./sum(distyh.*(1-phimat),1) ;
    FracLTCIlbyy  = sum(distyh.*(tlsmat>0).*phimat,2)'./sum(distyh.*phimat,2)' ;
    FracLTCIhbyy  = sum(distyh.*(thsmat>0).*(1-phimat),2)'./sum(distyh.*(1-phimat),2)' ;    
    FracLTCIlbyyh = phimat.*(tlsmat>0);
    FracLTCIhbyyh = (1-phimat).*(thsmat>0);
    [FracLTCIl_byhq_means,  FracLTCIl_byhq_shares] = get_dist_stats_x(FracLTCIlbyh, disth, phi_cutoffs, ng);
    [FracLTCIl_byyq_means,  FracLTCIl_byyq_shares] = get_dist_stats_x(FracLTCIlbyy, disty, y_cutoffs, ng);    
    [FracLTCIh_byhq_means,  FracLTCIh_byhq_shares] = get_dist_stats_x(FracLTCIhbyh, disth, phi_cutoffs, ng);
    [FracLTCIh_byyq_means,  FracLTCIh_byyq_shares] = get_dist_stats_x(FracLTCIhbyy, disty, y_cutoffs, ng);  
    
    FracSurvsLTCIvect(soltype) = (sum(sum(survprobslmat(tlsmat>0).*phimat(tlsmat>0).*distyh(tlsmat>0))) + ...
        sum(sum((1-phimat(thsmat>0)).*survprobshmat(thsmat>0).*distyh(thsmat>0))))/FracSurv;    
    FracSurvsLTCIbyyh = (phimat.*survprobslmat.*(tlsmat>0) + (1-phimat).*survprobshmat.*(thsmat>0))./FracSurvbyyh;
    
    FracSurvsLTCIbyh = sum((phimat.*survprobslmat.*(tlsmat>0) + (1-phimat).*survprobshmat.*(thsmat>0)).*distyh,1)./disth./FracSurvbyh;
    FracSurvsLTCIbyy = sum((phimat.*survprobslmat.*(tlsmat>0) + (1-phimat).*survprobshmat.*(thsmat>0)).*distyh,2)'./disty./FracSurvbyy;
    [FracSurvsLTCI_byhq_means,  FracSurvsLTCI_byhq_shares] = get_dist_stats_x(FracSurvsLTCIbyh, disth, phi_cutoffs, ng);
    [FracSurvsLTCI_byyq_means,  FracSurvsLTCI_byyq_shares] = get_dist_stats_x(FracSurvsLTCIbyy, disty, y_cutoffs, ng);    
    FracSurvsLTCIl  = sum(sum(distyh.*(tlsmat>0).*phimat.*survprobslmat))/sum(sum(distyh.*phimat.*survprobslmat)) ;
    FracSurvsLTCIh  = sum(sum(distyh.*(thsmat>0).*(1-phimat).*survprobshmat))/sum(sum(distyh.*(1-phimat).*survprobshmat)) ;            
    FracSurvsLTCIlbyyh = phimat.*survprobslmat.*(tlsmat>0);
    FracSurvsLTCIhbyyh = (1-phimat).*survprobshmat.*(thsmat>0);    
    
    FracLTCIbyyh_l = tlsmat>0;
    FracLTCIbyyh_h = thsmat>0;
    NHentrybyyh_l = survprobslmat.*sum(thetalmat.*distkappamat,3);
    NHentrybyyh_h = survprobshmat.*sum(thetahmat.*distkappamat,3);
   
    FracLTCsurvswhoEnterNH = (sum(sum(phimat.*distyh.*(tlsmat>0).*NHentrybyyh_l)) + sum(sum((1-phimat).*distyh.*(thsmat>0).*NHentrybyyh_h))) ...
        / (sum(sum(survprobslmat(tlsmat>0).*phimat(tlsmat>0).*distyh(tlsmat>0))) + ...
        sum(sum((1-phimat(thsmat>0)).*survprobshmat(thsmat>0).*distyh(thsmat>0))));
    
    FracNonLTCsurvswhoEnterNH = (sum(sum(phimat.*distyh.*(1-FracLTCIbyyh_l).*NHentrybyyh_l)) + sum(sum((1-phimat).*distyh.*(1-FracLTCIbyyh_h).*NHentrybyyh_h))) ...
        / (sum(sum(survprobslmat(tlsmat==0).*phimat(tlsmat==0).*distyh(tlsmat==0))) + ...
        sum(sum((1-phimat(thsmat==0)).*survprobshmat(thsmat==0).*distyh(thsmat==0))));
    
    FracLTCindswhoEnterNH = (sum(sum(phimat.*distyh.*(tlsmat>0).*NHentrybyyh_l)) + sum(sum((1-phimat).*distyh.*(thsmat>0).*NHentrybyyh_h))) ...
        / (sum(sum(phimat(tlsmat>0).*distyh(tlsmat>0))) + sum(sum((1-phimat(thsmat>0)).*distyh(thsmat>0))));
    
     FracNonLTCindswhoEnterNH = (sum(sum(phimat.*distyh.*(1-FracLTCIbyyh_l).*NHentrybyyh_l)) + sum(sum((1-phimat).*distyh.*(1-FracLTCIbyyh_h).*NHentrybyyh_h))) ...
        / (sum(sum(phimat(tlsmat==0).*distyh(tlsmat==0))) + sum(sum((1-phimat(thsmat==0)).*distyh(thsmat==0))));   

    %By frailty quintiles
    NumSurvsLTCINHbyh = (sum(phimat.*distyh.*(tlsmat>0).*NHentrybyyh_l,1) + sum((1-phimat).*distyh.*(thsmat>0).*NHentrybyyh_h,1))./disth;
    NumSurvsLTCIbyh = (sum(survprobslmat.*phimat.*distyh.*(tlsmat>0),1) + sum(survprobshmat.*(1-phimat).*distyh.*(thsmat>0),1))./disth;
    [FracLTCsurvswhoEnterNHn_byhq_means,  FracLTCsurvswhoEnterNH_byhq_shares] = get_dist_stats_x(NumSurvsLTCINHbyh, disth, phi_cutoffs, ng);
    [FracLTCsurvs_byhq_means,  FracLTCsurvs_byhq_shares] = get_dist_stats_x(NumSurvsLTCIbyh, disth, phi_cutoffs, ng);
    FracLTCsurvswhoEnterNH_byhq_means = FracLTCsurvswhoEnterNHn_byhq_means./FracLTCsurvs_byhq_means;
    
    NumSurvsNoLTCINHbyh = (sum(phimat.*distyh.*(tlsmat==0).*NHentrybyyh_l,1) + sum((1-phimat).*distyh.*(thsmat==0).*NHentrybyyh_h,1))./disth;
    NumSurvsNoLTCIbyh = (sum(survprobslmat.*phimat.*distyh.*(tlsmat==0),1) + sum(survprobshmat.*(1-phimat).*distyh.*(thsmat==0),1))./disth;
    [FracNonLTCsurvswhoEnterNHn_byhq_means,  FracNonLTCsurvswhoEnterNH_byhq_shares] = get_dist_stats_x(NumSurvsNoLTCINHbyh, disth, phi_cutoffs, ng);
    [FracNonLTCsurvs_byhq_means,  FracNonLTCsurvs_byhq_shares] = get_dist_stats_x(NumSurvsNoLTCIbyh, disth, phi_cutoffs, ng);
    FracNonLTCsurvswhoEnterNH_byhq_means = FracNonLTCsurvswhoEnterNHn_byhq_means./FracNonLTCsurvs_byhq_means;        
    
    NumIndsLTCIbyh = (sum(phimat.*distyh.*(tlsmat>0),1) + sum((1-phimat).*distyh.*(thsmat>0),1))./disth;   
    [FracLTCinds_byhq_means,  FracLTCinds_byhq_shares] = get_dist_stats_x(NumIndsLTCIbyh, disth, phi_cutoffs, ng);
    FracLTCindswhoEnterNH_byhq_means = FracLTCsurvswhoEnterNHn_byhq_means./FracLTCinds_byhq_means;
      
    NumIndsNoLTCIbyh = (sum(phimat.*distyh.*(tlsmat==0),1) + sum((1-phimat).*distyh.*(thsmat==0),1))./disth;   
    [FracNonLTCinds_byhq_means,  FracNonLTCinds_byhq_shares] = get_dist_stats_x(NumIndsNoLTCIbyh, disth, phi_cutoffs, ng);
    FracNonLTCindswhoEnterNH_byhq_means = FracNonLTCsurvswhoEnterNHn_byhq_means./FracNonLTCinds_byhq_means;    
    
    %By income quintiles
    NumSurvsLTCINHbyy = (sum(phimat.*distyh.*(tlsmat>0).*NHentrybyyh_l,2) + sum((1-phimat).*distyh.*(thsmat>0).*NHentrybyyh_h,2))'./disty;
    NumSurvsLTCIbyy = (sum(survprobslmat.*phimat.*distyh.*(tlsmat>0),2) + sum(survprobshmat.*(1-phimat).*distyh.*(thsmat>0),2))'./disty;
    [FracLTCsurvswhoEnterNHn_byyq_means,  FracLTCsurvswhoEnterNH_byyq_shares] = get_dist_stats_x(NumSurvsLTCINHbyy, disty, y_cutoffs, ng);
    [FracLTCsurvs_byyq_means,  FracLTCsurvs_byyq_shares] = get_dist_stats_x(NumSurvsLTCIbyy, disty, y_cutoffs, ng);
    FracLTCsurvswhoEnterNH_byyq_means = FracLTCsurvswhoEnterNHn_byyq_means./FracLTCsurvs_byyq_means;
    
    NumSurvsNoLTCINHbyy = (sum(phimat.*distyh.*(tlsmat==0).*NHentrybyyh_l,2) + sum((1-phimat).*distyh.*(thsmat==0).*NHentrybyyh_h,2))'./disty;
    NumSurvsNoLTCIbyy = (sum(survprobslmat.*phimat.*distyh.*(tlsmat==0),2) + sum(survprobshmat.*(1-phimat).*distyh.*(thsmat==0),2))'./disty;
    [FracNonLTCsurvswhoEnterNHn_byyq_means,  FracNonLTCsurvswhoEnterNH_byyq_shares] = get_dist_stats_x(NumSurvsNoLTCINHbyy, disty, y_cutoffs, ng);
    [FracNonLTCsurvs_byyq_means,  FracNonLTCsurvs_byyq_shares] = get_dist_stats_x(NumSurvsNoLTCIbyy, disty, y_cutoffs, ng);
    FracNonLTCsurvswhoEnterNH_byyq_means = FracNonLTCsurvswhoEnterNHn_byyq_means./FracNonLTCsurvs_byyq_means;        
    
    NumIndsLTCIbyy = (sum(phimat.*distyh.*(tlsmat>0),2) + sum((1-phimat).*distyh.*(thsmat>0),2))'./disty;   
    [FracLTCinds_byyq_means,  FracLTCinds_byyq_shares] = get_dist_stats_x(NumIndsLTCIbyy, disty, y_cutoffs, ng);
    FracLTCindswhoEnterNH_byyq_means = FracLTCsurvswhoEnterNHn_byyq_means./FracLTCinds_byyq_means;
      
    NumIndsNoLTCIbyy = (sum(phimat.*distyh.*(tlsmat==0),2) + sum((1-phimat).*distyh.*(thsmat==0),2))'./disty;   
    [FracNonLTCinds_byyq_means,  FracNonLTCinds_byyq_shares] = get_dist_stats_x(NumIndsNoLTCIbyy, disty, y_cutoffs, ng);
    FracNonLTCindswhoEnterNH_byyq_means = FracNonLTCsurvswhoEnterNHn_byyq_means./FracNonLTCinds_byyq_means;        
    


    RejectedLTCI = (tlsmat==0 & thsmat==0);
    NumWouldMTSIvect(soltype) = 0;
    NumMTSIvect(soltype) = 0;
    NumRejectedMTSIvect(soltype) = 0;
    NumRejectedNoMTSIvect(soltype) = 0;
    NumLTCIandMTSIvect(soltype) = 0;
    NumUseLTCIvect(soltype) = 0;
    NumNonNHLTCIvect(soltype) = 0;
    NumUseLTCIandMTSIvect(soltype) = 0;
    NumNHRejectedMTSIvect(soltype) = 0;
    NumNHRejectedNoMTSIvect(soltype) = 0;
    NumMTSIbyyh = zeros(ny,nh);
    NHcostsmat = zeros(ny,nh);
    NumUseLTCIbyh = zeros(1,nh);
    NumNonNHLTCIbyh = zeros(1,nh);
    NumUseLTCIbyy = zeros(1,ny);
    NumNonNHLTCIbyy = zeros(1,ny);    
    Avebenefitmat = zeros(ny,nh);
    NumRejectedMTSIbyh = zeros(1,nh);
    NumRejectedNoMTSIbyh = zeros(1,nh);
    NumRejectedMTSIbyy = zeros(1,ny);
    NumRejectedNoMTSIbyy = zeros(1,ny); 
    NumRejectedMTSIbyyh = zeros(ny,nh);
    NumRejectedNoMTSIbyyh = zeros(ny,nh);
    NumUseLTCIbyyh = zeros(ny,nh);
    NumNonNHLTCIbyyh = zeros(ny,nh); 
    NumWouldMTSIbyy = zeros(1,ny);
    for i=1:nk
        thetaltemp = thetalmat(:,:,i);
        thetahtemp = thetahmat(:,:,i);
        
        NumMTSIbyyh = NumMTSIbyyh + phimat.*survprobslmat.*MTSIl(:,:,i).*distkappa(i) + (1-phimat).*survprobshmat.*MTSIh(:,:,i).*distkappa(i);
        
        %number would get if survive and enter NH
        NumWouldMTSIvect(soltype) = NumWouldMTSIvect(soltype) + ...
            ( sum(sum(phimat(MTSIl(:,:,i)>0).*distyh(MTSIl(:,:,i)>0))) ...
            + sum(sum((1-phimat(MTSIh(:,:,i)>0)).*distyh(MTSIh(:,:,i)>0))) )*distkappa(i);
        
        %number actually got 
        NumMTSIvect(soltype) = NumMTSIvect(soltype) + ( sum(sum(phimat(MTSIl(:,:,i)>0).*survprobslmat(MTSIl(:,:,i)>0).*distyh(MTSIl(:,:,i)>0).*thetaltemp(MTSIl(:,:,i)>0))) ...
            + sum(sum((1-phimat(MTSIh(:,:,i)>0)).*survprobshmat(MTSIh(:,:,i)>0).*distyh(MTSIh(:,:,i)>0).*thetahtemp(MTSIh(:,:,i)>0))) )*distkappa(i);        
        
        NumRejectedMTSIvect(soltype) = NumRejectedMTSIvect(soltype) + sum(sum(phimat.*RejectedLTCI.*MTSIl(:,:,i).*distyh)).*distkappa(i) ...
            + sum(sum((1-phimat).*RejectedLTCI.*MTSIh(:,:,i).*distyh)).*distkappa(i);     
        
        NumRejectedNoMTSIvect(soltype) = NumRejectedNoMTSIvect(soltype) + sum(sum(phimat.*RejectedLTCI.*(1-MTSIl(:,:,i)).*distyh)).*distkappa(i) ...
            + sum(sum((1-phimat).*RejectedLTCI.*(1-MTSIh(:,:,i)).*distyh)).*distkappa(i);
        
        NumLTCIandMTSIvect(soltype) = NumLTCIandMTSIvect(soltype) + (sum(sum(phimat(tlsmat>0 & MTSIl(:,:,i)>0).*distyh(tlsmat>0& MTSIl(:,:,i)>0)))...
            + sum(sum((1-phimat(thsmat>0& MTSIh(:,:,i)>0)).*distyh(thsmat>0& MTSIh(:,:,i)>0))) ).*distkappa(i);
        
        NumUseLTCIvect(soltype) = NumUseLTCIvect(soltype) + (sum(sum(survprobslmat(tlsmat>0).*phimat(tlsmat>0).*distyh(tlsmat>0).*thetaltemp(tlsmat>0))) ...
            + sum(sum(survprobshmat(thsmat>0).*(1-phimat(thsmat>0)).*distyh(thsmat>0).*thetahtemp(thsmat>0)))   )*distkappa(i);
        
        NumNonNHLTCIvect(soltype) = NumNonNHLTCIvect(soltype) + (sum(sum(survprobslmat(tlsmat>0).*phimat(tlsmat>0).*distyh(tlsmat>0).*(1-thetaltemp(tlsmat>0)))) ...
            + sum(sum(survprobshmat(thsmat>0).*(1-phimat(thsmat>0)).*distyh(thsmat>0).*(1-thetahtemp(thsmat>0))))   )*distkappa(i);        
        
        NumUseLTCIandMTSIvect(soltype) = NumUseLTCIandMTSIvect(soltype) + ...
            (sum(sum(survprobslmat(tlsmat>0 & MTSIl(:,:,i)>0).*phimat(tlsmat>0 & MTSIl(:,:,i)>0).*distyh(tlsmat>0& MTSIl(:,:,i)>0).*thetaltemp(tlsmat>0 & MTSIl(:,:,i)>0)))...
            + sum(sum((1-phimat(thsmat>0& MTSIh(:,:,i)>0)).*survprobshmat(thsmat>0 & MTSIh(:,:,i)>0).*distyh(thsmat>0& MTSIh(:,:,i)>0).*thetahtemp(thsmat>0& MTSIh(:,:,i)>0))) ).*distkappa(i);
        
        NumNHRejectedMTSIvect(soltype) = NumNHRejectedMTSIvect(soltype) + sum(sum(phimat.*survprobslmat.*RejectedLTCI.*MTSIl(:,:,i).*distyh.*thetaltemp)).*distkappa(i) ...
            + sum(sum((1-phimat).*survprobshmat.*RejectedLTCI.*MTSIh(:,:,i).*distyh.*thetahtemp)).*distkappa(i);     
        
        NumNHRejectedNoMTSIvect(soltype) = NumNHRejectedNoMTSIvect(soltype) + sum(sum(phimat.*survprobslmat.*RejectedLTCI.*(1-MTSIl(:,:,i)).*distyh.*thetaltemp)).*distkappa(i) ...
            + sum(sum((1-phimat).*survprobshmat.*RejectedLTCI.*(1-MTSIh(:,:,i)).*distyh.*thetahtemp(i))).*distkappa(i);  
        
        NHcostsmat =  NHcostsmat + (phimat.*survprobslmat.*thetaltemp.*(clNHsmat(:,:,i))+...
            (1-phimat).*survprobshmat.*thetahtemp.*(chNHsmat(:,:,i)) )./(phimat.*survprobslmat.*thetaltemp+...
            (1-phimat).*survprobshmat.*thetahtemp) .*distkappa(i);  

        Avebenefitmat =  Avebenefitmat + (phimat.*survprobslmat.*thetaltemp.*(xlsmat)+...
            (1-phimat).*survprobshmat.*thetahtemp.*(xhsmat) )./(phimat.*survprobslmat.*thetaltemp+...
            (1-phimat).*survprobshmat.*thetahtemp)  .*distkappa(i);        
        
        NumUseLTCIbyh = NumUseLTCIbyh + sum( (survprobslmat.*(tlsmat>0).*phimat.*thetaltemp ...
            + survprobshmat.*(thsmat>0).*(1-phimat).*thetahtemp   )*distkappa(i).*distyh ,1)./disth ;        
        NumNonNHLTCIbyh = NumNonNHLTCIbyh + sum( (survprobslmat.*(tlsmat>0).*phimat.*(1-thetaltemp) ...
            + survprobshmat.*(thsmat>0).*(1-phimat).*(1-thetahtemp)   )*distkappa(i).*distyh ,1)./disth ; 

        NumUseLTCIbyy = NumUseLTCIbyy + sum( (survprobslmat.*(tlsmat>0).*phimat.*thetaltemp ...
            + survprobshmat.*(thsmat>0).*(1-phimat).*thetahtemp   )*distkappa(i).*distyh ,2)'./disty ;        
        NumNonNHLTCIbyy = NumNonNHLTCIbyy + sum( (survprobslmat.*(tlsmat>0).*phimat.*(1-thetaltemp) ...
            + survprobshmat.*(thsmat>0).*(1-phimat).*(1-thetahtemp)   )*distkappa(i).*distyh ,2)'./disty ;

        NumUseLTCIbyyh = NumUseLTCIbyyh +  (survprobslmat.*(tlsmat>0).*phimat.*thetaltemp ...
            + survprobshmat.*(thsmat>0).*(1-phimat).*thetahtemp   )*distkappa(i);        
        NumNonNHLTCIbyyh = NumNonNHLTCIbyyh +  (survprobslmat.*(tlsmat>0).*phimat.*(1-thetaltemp) ...
            + survprobshmat.*(thsmat>0).*(1-phimat).*(1-thetahtemp)   )*distkappa(i)  ; 

        NumRejectedMTSIbyh= NumRejectedMTSIbyh + sum(phimat.*RejectedLTCI.*MTSIl(:,:,i).*distyh,1).*distkappa(i)./disth ...
            + sum((1-phimat).*RejectedLTCI.*MTSIh(:,:,i).*distyh,1).*distkappa(i)./disth;     
        
        NumRejectedNoMTSIbyh = NumRejectedNoMTSIbyh + sum(phimat.*RejectedLTCI.*(1-MTSIl(:,:,i)).*distyh,1).*distkappa(i)./disth ...
            + sum((1-phimat).*RejectedLTCI.*(1-MTSIh(:,:,i)).*distyh,1).*distkappa(i)./disth;        
        
        NumRejectedMTSIbyy= NumRejectedMTSIbyy + sum(phimat.*RejectedLTCI.*MTSIl(:,:,i).*distyh,2)'.*distkappa(i)./disty ...
            + sum((1-phimat).*RejectedLTCI.*MTSIh(:,:,i).*distyh,2)'.*distkappa(i)./disty;     
        
        NumRejectedNoMTSIbyy = NumRejectedNoMTSIbyy + sum(phimat.*RejectedLTCI.*(1-MTSIl(:,:,i)).*distyh,2)'.*distkappa(i)./disty ...
            + sum((1-phimat).*RejectedLTCI.*(1-MTSIh(:,:,i)).*distyh,2)'.*distkappa(i)./disty;          
        
        NumRejectedMTSIbyyh= NumRejectedMTSIbyyh + phimat.*RejectedLTCI.*MTSIl(:,:,i).*distkappa(i) ...
            + (1-phimat).*RejectedLTCI.*MTSIh(:,:,i).*distkappa(i);     
        
        NumRejectedNoMTSIbyyh = NumRejectedNoMTSIbyyh + phimat.*RejectedLTCI.*(1-MTSIl(:,:,i)).*distkappa(i) ...
            + (1-phimat).*RejectedLTCI.*(1-MTSIh(:,:,i)).*distkappa(i);        
        
        NumWouldMTSIbyy = NumWouldMTSIbyy + ...
             sum(phimat.*distyh.*MTSIl(:,:,i),2)'.*distkappa(i)./disty ...
            + sum((1-phimat).*distyh.*MTSIh(:,:,i),2)'.*distkappa(i)./disty;         
    end
    

    
    NHcostsmat = NHcostsmat*0.081385./sum(sum(NHcostsmat.*distyh));
    NHcostsmat = NHcostsmat + l;
    
    %By frailty quintiles
    [FracNHuseLTCI_byhq_means,  FracNHuseLTCI_byhq_shares] = get_dist_stats_x(NumUseLTCIbyh, disth, phi_cutoffs, ng);
    FracNHuseLTCI_byhq_means = FracNHuseLTCI_byhq_means./NHentry_byhq_means;
    [FracNonNHuseLTCI_byhq_means,  FracNonNHuseLTCI_byhq_shares] = get_dist_stats_x(NumNonNHLTCIbyh, disth, phi_cutoffs, ng);
    FracNonNHuseLTCI_byhq_means = FracNonNHuseLTCI_byhq_means./(survs_byhq_means- NHentry_byhq_means);    
    
    %By income quintiles 
    [FracNHuseLTCI_byyq_means,  FracNHuseLTCI_byyq_shares] = get_dist_stats_x(NumUseLTCIbyy, disty, y_cutoffs, ng);     
    FracNHuseLTCI_byyq_means = FracNHuseLTCI_byyq_means./NHentry_byyq_means;
    [FracNonNHuseLTCI_byyq_means,  FracNonNHuseLTCI_byyq_shares] = get_dist_stats_x(NumNonNHLTCIbyy, disty, y_cutoffs, ng);
    FracNonNHuseLTCI_byyq_means = FracNonNHuseLTCI_byyq_means./(survs_byyq_means- NHentry_byyq_means);

    [NumWouldMTSI_byyq_means,  NumWouldMTSI_byyq_shares] = get_dist_stats_x(NumWouldMTSIbyy, disty, y_cutoffs, ng);
    %NumWouldMTSI_byyq_means = NumWouldMTSI_byyq_means./(survs_byyq_means- NHentry_byyq_means);
    
    %By income quartiles
    [y_qrmeans,  y_qrshares, y_qrvalues, y_qrcutoffs] = get_dist_stats(ygrid, disty, linspace(1/4,1,4));
    [NHentry_byyqr_means,  NHentry_byyqr_shares] = get_dist_stats_x(FracEnterNHbyy, disty, y_qrcutoffs, 4);
    [survs_byyqr_means,  survs_byyqr_shares] = get_dist_stats_x(FracSurvbyy, disty, y_qrcutoffs, 4);    
    [FracNHuseLTCI_byyqr_means,  FracNHuseLTCI_byyqr_shares] = get_dist_stats_x(NumUseLTCIbyy, disty, y_qrcutoffs, 4);     
    FracNHuseLTCI_byyqr_means = FracNHuseLTCI_byyqr_means./NHentry_byyqr_means;
    [FracNonNHuseLTCI_byyqr_means,  FracNonNHuseLTCI_byyqr_shares] = get_dist_stats_x(NumNonNHLTCIbyy, disty, y_qrcutoffs, 4);
    FracNonNHuseLTCI_byyqr_means = FracNonNHuseLTCI_byyqr_means./(survs_byyqr_means- NHentry_byyqr_means);    
    
    FracRejectedvect(soltype) = sum(sum(phimat(tlsmat==0 & thsmat==0).*distyh(tlsmat==0 & thsmat==0))) ...
        + sum(sum((1-phimat(tlsmat==0 & thsmat==0)).*distyh(tlsmat==0 & thsmat==0)));
    [FracRejected_byhq_means,  FracRejected_byhq_shares] = get_dist_stats_x(NumRejectedMTSIbyh+NumRejectedNoMTSIbyh, disth, phi_cutoffs, ng);
    [FracRejectedMTSI_byhq_means,  FracRejectedMTSI_byhq_shares] = get_dist_stats_x(NumRejectedMTSIbyh, disth, phi_cutoffs, ng);
    [FracRejectedNoMTSI_byhq_means,  FracRejectedNoMTSI_byhq_shares] = get_dist_stats_x(NumRejectedNoMTSIbyh, disth, phi_cutoffs, ng);
    [FracRejected_byyq_means,  FracRejected_byyq_shares] = get_dist_stats_x(NumRejectedMTSIbyy+NumRejectedNoMTSIbyy, disty, y_cutoffs, ng);
    [FracRejectedMTSI_byyq_means,  FracRejectedMTSI_byyq_shares] = get_dist_stats_x(NumRejectedMTSIbyy, disty, y_cutoffs, ng);
    [FracRejectedNoMTSI_byyq_means,  FracRejectedNoMTSI_byyq_shares] = get_dist_stats_x(NumRejectedNoMTSIbyy, disty, y_cutoffs, ng);    
    
    %Rejection rates: 90th, 95th and 99th breakdowns
    [FracRejected_byyq_uppermeans1,  FracRejected_byyq_uppershares1] = get_dist_stats_xupper(NumRejectedMTSIbyy+NumRejectedNoMTSIbyy, disty, [y_pcutoffs(2) ny], 2, [0.9 0.1]);
    [FracRejected_byyq_uppermeans2,  FracRejected_byyq_uppershares2] = get_dist_stats_xupper(NumRejectedMTSIbyy+NumRejectedNoMTSIbyy, disty, [y_pcutoffs(3) ny], 2, [0.95 0.05]);
    [FracRejected_byyq_uppermeans3,  FracRejected_byyq_uppershares3] = get_dist_stats_xupper(NumRejectedMTSIbyy+NumRejectedNoMTSIbyy, disty, [y_pcutoffs(4) ny], 2, [0.99 0.01]);
    
 
     %LTCI take-up rates: 90th, 95th and 99th breakdowns
    [LTCI_byyq_uppermeans1,  LTCI_byyq_uppershares1] = get_dist_stats_xupper(FracLTCIbyy, disty, [y_pcutoffs(2) ny], 2, [0.9 0.1]);
    [LTCI_byyq_uppermeans2,  LTCI_byyq_uppershares2] = get_dist_stats_xupper(FracLTCIbyy, disty, [y_pcutoffs(3) ny], 2, [0.95 0.05]);
    [LTCI_byyq_uppermeans3,  LTCI_byyq_uppershares3] = get_dist_stats_xupper(FracLTCIbyy, disty, [y_pcutoffs(4) ny], 2, [0.99 0.01]);

    
    %Frac survivors use: LTCI only, MTSI only, both, neither
    InsUsevect = [(NumUseLTCIvect(soltype)-NumUseLTCIandMTSIvect(soltype))./FracSurv, (NumMTSIvect(soltype)-NumUseLTCIandMTSIvect(soltype))./FracSurv,...
     NumUseLTCIandMTSIvect(soltype)./FracSurv, 1-NumUseLTCIvect(soltype)./FracSurv-NumMTSIvect(soltype)./FracSurv+NumUseLTCIandMTSIvect(soltype)./FracSurv];     
 
    %Frac NH entrants use: LTCI Only, MTSI Only, Both, Neither: 
    InsUseNHvect = [(NumUseLTCIvect(soltype)-NumUseLTCIandMTSIvect(soltype))/FracEnterNH, (NumMTSIvect(soltype)-NumUseLTCIandMTSIvect(soltype))/FracEnterNH,...
         (NumUseLTCIandMTSIvect(soltype))/FracEnterNH, (FracEnterNH-NumUseLTCIvect(soltype)-NumMTSIvect(soltype)+NumUseLTCIandMTSIvect(soltype))/FracEnterNH];
 
    %Frac NH entrants: Use LTCI, Denied (get MTSI), Denied (no MTSI), Not denied
    LTCIStatusNHvect = [NumUseLTCIvect(soltype)/FracEnterNH, NumNHRejectedMTSIvect(soltype)/FracEnterNH,...
         NumNHRejectedNoMTSIvect(soltype)/FracEnterNH,(FracEnterNH-NumUseLTCIvect(soltype)-NumNHRejectedMTSIvect(soltype)-NumNHRejectedNoMTSIvect(soltype))/FracEnterNH];

    %Frac 65 year olds (before death) have: LTCI Only, MTSI Only, Both, Neither
    InsHavevect = [FracLTCIvect(soltype)-NumLTCIandMTSIvect(soltype),NumWouldMTSIvect(soltype)-NumLTCIandMTSIvect(soltype),...
     NumLTCIandMTSIvect(soltype), 1-FracLTCIvect(soltype)-NumWouldMTSIvect(soltype)+NumLTCIandMTSIvect(soltype)];
    
    %Frac 65 year olds (before death): LTCI, Denied LTCI (MTSI), Denied LTCI (no MTSI), Not denied
    LTCIStatusvect = [FracLTCIvect(soltype),NumRejectedMTSIvect(soltype),NumRejectedNoMTSIvect(soltype),...
     1-FracLTCIvect(soltype)-FracRejectedvect(soltype)];         
     

% FracEnterNHbyyh    
% FracSurvbyyh-FracEnterNHbyyh  
     
    %premia by frailty, income and type
    Premiabyh = (sum(phimat.*distyh.*tlsmat,1) + sum((1-phimat).*distyh.*thsmat,1))./disth;   
    Premiabyy = (sum(phimat.*distyh.*tlsmat,2) + sum((1-phimat).*distyh.*thsmat,2))'./disty;   
    Premiabyyh = phimat.*tlsmat + (1-phimat).*thsmat;   
    [Premia_byhq_means,  Premia_byhq_shares] = get_dist_stats_x(Premiabyh, disth, phi_cutoffs, ng);
    Premia_byhq_means = Premia_byhq_means./FracLTCI_byhq_means;        
    [Premia_byyq_means,  Premia_byyq_shares] = get_dist_stats_x(Premiabyy, disty, y_cutoffs, ng);
    Premia_byyq_means = Premia_byyq_means./FracLTCI_byyq_means;            
        
    Premial = sum(sum( distyh.*phimat.*tlsmat ))./sum(sum(distyh.*(tlsmat>0).*phimat));
    Premiah = sum(sum( distyh.*(1-phimat).*thsmat ))./sum(sum(distyh.*(thsmat>0).*(1-phimat)));     
    Premialbyh = sum( distyh.*(phimat.*tlsmat) ,1)./sum(distyh.*phimat,1); 
    Premialbyy = sum( distyh.*(phimat.*tlsmat) ,2)'./sum(distyh.*phimat,2)'; 
    Premiahbyh = sum( distyh.*((1-phimat).*thsmat) ,1)./sum(distyh.*(1-phimat),1); 
    Premiahbyy = sum( distyh.*((1-phimat).*thsmat) ,2)'./sum(distyh.*(1-phimat),2)';
    [Premial_byhq_means,  Premial_byhq_shares] = get_dist_stats_x(Premialbyh, disth, phi_cutoffs, ng);
    Premial_byhq_means = Premial_byhq_means./FracLTCIl_byhq_means;        
    [Premial_byyq_means,  Premial_byyq_shares] = get_dist_stats_x(Premialbyy, disty, y_cutoffs, ng);
    Premial_byyq_means = Premial_byyq_means./FracLTCIl_byyq_means;      
    [Premiah_byhq_means,  Premiah_byhq_shares] = get_dist_stats_x(Premiahbyh, disth, phi_cutoffs, ng);
    Premiah_byhq_means = Premiah_byhq_means./FracLTCIh_byhq_means;        
    [Premiah_byyq_means,  Premiah_byyq_shares] = get_dist_stats_x(Premiahbyy, disty, y_cutoffs, ng);
    Premiah_byyq_means = Premiah_byyq_means./FracLTCIh_byyq_means;
        
    %loads: 1- (EPDV benefits/EPDV premiums) (x theta/t)
    %benefit to loss ratios
    loadhmat = 1-xhsmat.*survprobshmat.*sum(thetahmat.*distkappamat,3)./thsmat;
    loadhmat(thsmat==0) = 0;
    fracCoveredhmat = xhsmat./(l);    
    loadlmat = 1-xlsmat.*survprobslmat.*sum(thetalmat.*distkappamat,3)./tlsmat;
    loadlmat(tlsmat==0) = 0;
    fracCoveredlmat = xlsmat./(l);
    Aveloadvect(soltype) = sum(sum( distyh.*(phimat.*loadlmat+(1-phimat).*loadhmat) ))./FracLTCIvect(soltype);
    AveFracCovered(soltype) = sum(sum( distyh.*(phimat.*fracCoveredlmat+(1-phimat).*fracCoveredhmat) ))./FracLTCIvect(soltype);        

    benefitcostratio(soltype)  = sum(sum(Avebenefitmat./NHcostsmat.*distyh))./FracLTCIvect(soltype);  
    
    admincostyhmat = (1-phimat).*((lambda-1).*xhsmat+k.*(xhsmat>0)).*survprobshmat.*sum(thetahmat.*distkappamat,3) +...
        (phimat).*((lambda-1).*xlsmat+k.*(xlsmat>0)).*survprobslmat.*sum(thetalmat.*distkappamat,3);
    costspremiaratio(soltype) = sum(sum(distyh.*admincostyhmat))./sum(sum(distyh.*((1-phimat).*thsmat+phimat.*tlsmat)));
    
    admincostyhmatl = (1-phimat).*((lambda-1).*xhsmat).*survprobshmat.*sum(thetahmat.*distkappamat,3) +...
        (phimat).*((lambda-1).*xlsmat).*survprobslmat.*sum(thetalmat.*distkappamat,3);    
    costspremiaratiol= sum(sum(distyh.*admincostyhmatl))./sum(sum(distyh.*((1-phimat).*thsmat+phimat.*tlsmat))); 
    admincostyhmatk = (1-phimat).*(k.*(xhsmat>0)).*survprobshmat.*sum(thetahmat.*distkappamat,3) +...
        (phimat).*(k.*(xlsmat>0)).*survprobslmat.*sum(thetalmat.*distkappamat,3);   
    costspremiaratiok= sum(sum(distyh.*admincostyhmatk))./sum(sum(distyh.*((1-phimat).*thsmat+phimat.*tlsmat)));     
    
    %loads by frailty, income and type
    loadl = sum(sum( distyh.*phimat.*loadlmat ))./sum(sum(distyh.*(tlsmat>0).*phimat));
    loadh = sum(sum( distyh.*(1-phimat).*loadhmat ))./sum(sum(distyh.*(thsmat>0).*(1-phimat))); 
    loadsbyh = (sum(phimat.*distyh.*loadlmat,1) + sum((1-phimat).*distyh.*loadhmat,1))./disth;   
    loadsbyy = (sum(phimat.*distyh.*loadlmat,2) + sum((1-phimat).*distyh.*loadhmat,2))'./disty;   
    loadsbyyh = phimat.*loadlmat + (1-phimat).*loadhmat;   
    [loads_byhq_means,  loads_byhq_shares] = get_dist_stats_x(loadsbyh, disth, phi_cutoffs, ng);
    loads_byhq_means = loads_byhq_means./FracLTCI_byhq_means;        
    [loads_byyq_means,  loads_byyq_shares] = get_dist_stats_x(loadsbyy, disty, y_cutoffs, ng);
    loads_byyq_means = loads_byyq_means./FracLTCI_byyq_means;            
    
    loadlbyh = sum( distyh.*(phimat.*loadlmat) ,1)./sum(distyh.*phimat,1); 
    loadlbyy = sum( distyh.*(phimat.*loadlmat) ,2)'./sum(distyh.*phimat,2)'; 
    loadhbyh = sum( distyh.*((1-phimat).*loadhmat) ,1)./sum(distyh.*(1-phimat),1); 
    loadhbyy = sum( distyh.*((1-phimat).*loadhmat) ,2)'./sum(distyh.*(1-phimat),2)';
    [loadl_byhq_means,  loadl_byhq_shares] = get_dist_stats_x(loadlbyh, disth, phi_cutoffs, ng);
    loadl_byhq_means = loadl_byhq_means./FracLTCIl_byhq_means;        
    [loadl_byyq_means,  loadl_byyq_shares] = get_dist_stats_x(loadlbyy, disty, y_cutoffs, ng);
    loadl_byyq_means = loadl_byyq_means./FracLTCIl_byyq_means;      
    [loadh_byhq_means,  loadh_byhq_shares] = get_dist_stats_x(loadhbyh, disth, phi_cutoffs, ng);
    loadh_byhq_means = loadh_byhq_means./FracLTCIh_byhq_means;        
    [loadh_byyq_means,  loadh_byyq_shares] = get_dist_stats_x(loadhbyy, disty, y_cutoffs, ng);
    loadh_byyq_means = loadh_byyq_means./FracLTCIh_byyq_means;     
    
    %fraction of medical costs covered by indeminty by frailty and income
    FracCoveredbyh = (sum(phimat.*distyh.*fracCoveredlmat,1) + sum((1-phimat).*distyh.*fracCoveredhmat,1))./disth;   
    FracCoveredbyy = (sum(phimat.*distyh.*fracCoveredlmat,2) + sum((1-phimat).*distyh.*fracCoveredhmat,2))'./disty;   
    FracCoveredbyyh = phimat.*fracCoveredlmat + (1-phimat).*fracCoveredhmat;   
    [FracCovered_byhq_means,  FracCovered_byhq_shares] = get_dist_stats_x(FracCoveredbyh, disth, phi_cutoffs, ng);
    FracCovered_byhq_means = FracCovered_byhq_means./FracLTCI_byhq_means;        
    [FracCovered_byyq_means,  FracCovered_byyq_shares] = get_dist_stats_x(FracCoveredbyy, disty, y_cutoffs, ng);
    FracCovered_byyq_means = FracCovered_byyq_means./FracLTCI_byyq_means;     
        
    FracCoveredl = sum(sum( distyh.*(phimat.*fracCoveredlmat) ))./sum(sum(distyh.*(tlsmat>0).*phimat)); 
    FracCoveredh = sum(sum( distyh.*((1-phimat).*fracCoveredhmat) ))./ sum(sum(distyh.*(thsmat>0).*(1-phimat))); 
    FracCoveredlbyh = sum( distyh.*(phimat.*fracCoveredlmat) ,1)./sum(distyh.*phimat,1); 
    FracCoveredlbyy = sum( distyh.*(phimat.*fracCoveredlmat) ,2)'./sum(distyh.*phimat,2)'; 
    FracCoveredhbyh = sum( distyh.*((1-phimat).*fracCoveredhmat) ,1)./sum(distyh.*(1-phimat),1); 
    FracCoveredhbyy = sum( distyh.*((1-phimat).*fracCoveredhmat) ,2)'./sum(distyh.*(1-phimat),2)';
    [FracCoveredl_byhq_means,  FracCoveredl_byhq_shares] = get_dist_stats_x(FracCoveredlbyh, disth, phi_cutoffs, ng);
    FracCoveredl_byhq_means = FracCoveredl_byhq_means./FracLTCIl_byhq_means;        
    [FracCoveredl_byyq_means,  FracCoveredl_byyq_shares] = get_dist_stats_x(FracCoveredlbyy, disty, y_cutoffs, ng);
    FracCoveredl_byyq_means = FracCoveredl_byyq_means./FracLTCIl_byyq_means;      
    [FracCoveredh_byhq_means,  FracCoveredh_byhq_shares] = get_dist_stats_x(FracCoveredhbyh, disth, phi_cutoffs, ng);
    FracCoveredh_byhq_means = FracCoveredh_byhq_means./FracLTCIh_byhq_means;        
    [FracCoveredh_byyq_means,  FracCoveredh_byyq_shares] = get_dist_stats_x(FracCoveredhbyy, disty, y_cutoffs, ng);
    FracCoveredh_byyq_means = FracCoveredh_byyq_means./FracLTCIh_byyq_means;       

%% income frailty moments
    
    
    yt_vect = reshape(ymat,1,ny*nh);
    distyhvect = reshape(distyh,1,ny*nh);
    [yt_vect, ind_sort] = sort(yt_vect);
    distyhvect = distyhvect(ind_sort);
    ng = 5;
    yt_mean = sum(yt_vect.*distyhvect);
    [yt_qmeans,  yt_shares, yt_qvalues, ytcutoffs] = get_dist_stats(yt_vect, distyhvect, linspace(1/ng,1,ng));
    [yt_pmeansBAD,  yt_psharesBAD, yt_pvalues, yt_pcutoffs] = get_dist_stats(yt_vect, distyhvect, [0.5 0.9 0.95 0.99]);
    yt_gini=get_gini(distyhvect,yt_vect);      
    [yt_qrmeans,  yt_qrshares, yt_qrvalues, yt_qrcutoffs] = get_dist_stats(yt_vect, distyhvect, linspace(1/4,1,4));
    
    ytmattemp =zeros(ny,nh);
    for ii=ng:-1:1
        ytmattemp( (ymat < yt_qvalues(ii)) ) = ii;
        ytmattemp(ymat==yt_qvalues(ii)) = ii+5;
    end
    %asmattemp(58,5) = 4;
    
    %Fraction buy LTCI by income and frailty quintile both types
    fracInds = zeros(ng,ng);
    fracLTCIInds = zeros(ng,ng);
    for jj=1:ng
    for ii=1:ng
        fracInds(ii,jj) = sum(distyh(ytmattemp(:,jj)==ii,jj)) + ...
            sum(distyh(ytmattemp(:,jj)==ii+5,jj)).*( 0.2*ii- sum(distyh(ytmattemp<=ii))-sum(distyh(ytmattemp>5 & ytmattemp<ii+5 )))/sum(distyh(ytmattemp==ii+5));
         if (ii>1)
             fracInds(ii,jj) = fracInds(ii,jj) + ...
                 sum(distyh(ytmattemp(:,jj)==ii+4,jj)).*(1-( 0.2*(ii-1)- sum(distyh(ytmattemp<=ii-1))-sum(distyh(ytmattemp>5 & ytmattemp<ii+4 )))/sum(distyh(ytmattemp==ii+4)));
         end
         fracLTCIInds(ii,jj) = sum(distyh(ytmattemp(:,jj)==ii,jj).*FracLTCIbyyh(ytmattemp(:,jj)==ii,jj) ) + ...
            sum(distyh(ytmattemp(:,jj)==ii+5,jj).*FracLTCIbyyh(ytmattemp(:,jj)==ii+5,jj)).*( 0.2*ii- sum(distyh(ytmattemp<=ii))-sum(distyh(ytmattemp>5 & ytmattemp<ii+5 )))/sum(distyh(ytmattemp==ii+5));
         if (ii>1)
             fracLTCIInds(ii,jj) = fracLTCIInds(ii,jj) + ...
                 sum(distyh(ytmattemp(:,jj)==ii+4,jj).*FracLTCIbyyh(ytmattemp(:,jj)==ii+4,jj)).*(1-( 0.2*(ii-1)- sum(distyh(ytmattemp<=ii-1))-sum(distyh(ytmattemp>5 & ytmattemp<ii+4 )))/sum(distyh(ytmattemp==ii+4)));
         end  
         %keyboard
    end
    end
    FracLTCIbyyhq= fracLTCIInds./fracInds;
    %fraction LTCI by income and frailty quintile. 
    FracLTCIbyyhq = FracLTCIbyyhq';
 
    
    %Fraction enter NH by income and frailty quintile both types
    fracInds = zeros(ng,ng);
    fracNHInds = zeros(ng,ng);
    for jj=1:ng
    for ii=1:ng
        fracInds(ii,jj) = sum(distyh(ytmattemp(:,jj)==ii,jj)) + ...
            sum(distyh(ytmattemp(:,jj)==ii+5,jj)).*( 0.2*ii- sum(distyh(ytmattemp<=ii))-sum(distyh(ytmattemp>5 & ytmattemp<ii+5 )))/sum(distyh(ytmattemp==ii+5));
         if (ii>1)
             fracInds(ii,jj) = fracInds(ii,jj) + ...
                 sum(distyh(ytmattemp(:,jj)==ii+4,jj)).*(1-( 0.2*(ii-1)- sum(distyh(ytmattemp<=ii-1))-sum(distyh(ytmattemp>5 & ytmattemp<ii+4 )))/sum(distyh(ytmattemp==ii+4)));
         end
         fracNHInds(ii,jj) = sum(distyh(ytmattemp(:,jj)==ii,jj).*FracEnterNHbyyh(ytmattemp(:,jj)==ii,jj) ) + ...
            sum(distyh(ytmattemp(:,jj)==ii+5,jj).*FracEnterNHbyyh(ytmattemp(:,jj)==ii+5,jj)).*( 0.2*ii- sum(distyh(ytmattemp<=ii))-sum(distyh(ytmattemp>5 & ytmattemp<ii+5 )))/sum(distyh(ytmattemp==ii+5));
         if (ii>1)
             fracNHInds(ii,jj) = fracNHInds(ii,jj) + ...
                 sum(distyh(ytmattemp(:,jj)==ii+4,jj).*FracEnterNHbyyh(ytmattemp(:,jj)==ii+4,jj)).*(1-( 0.2*(ii-1)- sum(distyh(ytmattemp<=ii-1))-sum(distyh(ytmattemp>5 & ytmattemp<ii+4 )))/sum(distyh(ytmattemp==ii+4)));
         end  
         %keyboard
    end
    end
    NHentrybyyhq= fracNHInds./fracInds;
    %fraction enter NH by income and frailty quintile. 
    NHentrybyyhq = NHentrybyyhq';   
    
    %Fraction survivors enter NH by income and frailty quintile both types
    fracInds = zeros(ng,ng);
    fracNHInds = zeros(ng,ng);
    for jj=1:ng
    for ii=1:ng
        fracInds(ii,jj) = sum(distyh(ytmattemp(:,jj)==ii,jj)) + ...
            sum(distyh(ytmattemp(:,jj)==ii+5,jj)).*( 0.2*ii- sum(distyh(ytmattemp<=ii))-sum(distyh(ytmattemp>5 & ytmattemp<ii+5 )))/sum(distyh(ytmattemp==ii+5));
         if (ii>1)
             fracInds(ii,jj) = fracInds(ii,jj) + ...
                 sum(distyh(ytmattemp(:,jj)==ii+4,jj)).*(1-( 0.2*(ii-1)- sum(distyh(ytmattemp<=ii-1))-sum(distyh(ytmattemp>5 & ytmattemp<ii+4 )))/sum(distyh(ytmattemp==ii+4)));
         end
         fracNHInds(ii,jj) = sum(distyh(ytmattemp(:,jj)==ii,jj).*FracSurvsEnterNHbyyh(ytmattemp(:,jj)==ii,jj) ) + ...
            sum(distyh(ytmattemp(:,jj)==ii+5,jj).*FracSurvsEnterNHbyyh(ytmattemp(:,jj)==ii+5,jj)).*( 0.2*ii- sum(distyh(ytmattemp<=ii))-sum(distyh(ytmattemp>5 & ytmattemp<ii+5 )))/sum(distyh(ytmattemp==ii+5));
         if (ii>1)
             fracNHInds(ii,jj) = fracNHInds(ii,jj) + ...
                 sum(distyh(ytmattemp(:,jj)==ii+4,jj).*FracSurvsEnterNHbyyh(ytmattemp(:,jj)==ii+4,jj)).*(1-( 0.2*(ii-1)- sum(distyh(ytmattemp<=ii-1))-sum(distyh(ytmattemp>5 & ytmattemp<ii+4 )))/sum(distyh(ytmattemp==ii+4)));
         end  
         %keyboard
    end
    end
    FracSurvsEnterNHbyyhq= fracNHInds./fracInds;
    %fraction enter NH by income and frailty quintile. 
    FracSurvsEnterNHbyyhq = FracSurvsEnterNHbyyhq';       
    
    %Fraction low types enter NH by income and frailty quintile both types
    FracEnterNHbyyh_l = survprobslmat.*sum(thetalmat.*distkappamat,3);
    fracInds = zeros(ng,ng);
    fracNHInds = zeros(ng,ng);
    for jj=1:ng
    for ii=1:ng
        fracInds(ii,jj) = sum(distyh(ytmattemp(:,jj)==ii,jj)) + ...
            sum(distyh(ytmattemp(:,jj)==ii+5,jj)).*( 0.2*ii- sum(distyh(ytmattemp<=ii))-sum(distyh(ytmattemp>5 & ytmattemp<ii+5 )))/sum(distyh(ytmattemp==ii+5));
         if (ii>1)
             fracInds(ii,jj) = fracInds(ii,jj) + ...
                 sum(distyh(ytmattemp(:,jj)==ii+4,jj)).*(1-( 0.2*(ii-1)- sum(distyh(ytmattemp<=ii-1))-sum(distyh(ytmattemp>5 & ytmattemp<ii+4 )))/sum(distyh(ytmattemp==ii+4)));
         end
         fracNHInds(ii,jj) = sum(distyh(ytmattemp(:,jj)==ii,jj).*FracEnterNHbyyh_l(ytmattemp(:,jj)==ii,jj) ) + ...
            sum(distyh(ytmattemp(:,jj)==ii+5,jj).*FracEnterNHbyyh_l(ytmattemp(:,jj)==ii+5,jj)).*( 0.2*ii- sum(distyh(ytmattemp<=ii))-sum(distyh(ytmattemp>5 & ytmattemp<ii+5 )))/sum(distyh(ytmattemp==ii+5));
         if (ii>1)
             fracNHInds(ii,jj) = fracNHInds(ii,jj) + ...
                 sum(distyh(ytmattemp(:,jj)==ii+4,jj).*FracEnterNHbyyh_l(ytmattemp(:,jj)==ii+4,jj)).*(1-( 0.2*(ii-1)- sum(distyh(ytmattemp<=ii-1))-sum(distyh(ytmattemp>5 & ytmattemp<ii+4 )))/sum(distyh(ytmattemp==ii+4)));
         end  
         %keyboard
    end
    end
    NHentrybyyhq_l= fracNHInds./fracInds;
    %fraction low types enter NH by income and frailty quintile. 
    NHentrybyyhq_l = NHentrybyyhq_l';    
    
    %Fraction high types enter NH by income and frailty quintile both types
    FracEnterNHbyyh_h = survprobshmat.*sum(thetahmat.*distkappamat,3);
    fracInds = zeros(ng,ng);
    fracNHInds = zeros(ng,ng);
    for jj=1:ng
    for ii=1:ng
        fracInds(ii,jj) = sum(distyh(ytmattemp(:,jj)==ii,jj)) + ...
            sum(distyh(ytmattemp(:,jj)==ii+5,jj)).*( 0.2*ii- sum(distyh(ytmattemp<=ii))-sum(distyh(ytmattemp>5 & ytmattemp<ii+5 )))/sum(distyh(ytmattemp==ii+5));
         if (ii>1)
             fracInds(ii,jj) = fracInds(ii,jj) + ...
                 sum(distyh(ytmattemp(:,jj)==ii+4,jj)).*(1-( 0.2*(ii-1)- sum(distyh(ytmattemp<=ii-1))-sum(distyh(ytmattemp>5 & ytmattemp<ii+4 )))/sum(distyh(ytmattemp==ii+4)));
         end
         fracNHInds(ii,jj) = sum(distyh(ytmattemp(:,jj)==ii,jj).*FracEnterNHbyyh_h(ytmattemp(:,jj)==ii,jj) ) + ...
            sum(distyh(ytmattemp(:,jj)==ii+5,jj).*FracEnterNHbyyh_h(ytmattemp(:,jj)==ii+5,jj)).*( 0.2*ii- sum(distyh(ytmattemp<=ii))-sum(distyh(ytmattemp>5 & ytmattemp<ii+5 )))/sum(distyh(ytmattemp==ii+5));
         if (ii>1)
             fracNHInds(ii,jj) = fracNHInds(ii,jj) + ...
                 sum(distyh(ytmattemp(:,jj)==ii+4,jj).*FracEnterNHbyyh_h(ytmattemp(:,jj)==ii+4,jj)).*(1-( 0.2*(ii-1)- sum(distyh(ytmattemp<=ii-1))-sum(distyh(ytmattemp>5 & ytmattemp<ii+4 )))/sum(distyh(ytmattemp==ii+4)));
         end  
         %keyboard
    end
    end
    NHentrybyyhq_h= fracNHInds./fracInds;
    %fraction high types enter NH by income and frailty quintile. 
    NHentrybyyhq_h = NHentrybyyhq_h';      
   
    %Fraction low types who survive enter NH by income and frailty quintile both types
    FracSurvsEnterNHbyyh_l = sum(thetalmat.*distkappamat,3);
    fracInds = zeros(ng,ng);
    fracNHInds = zeros(ng,ng);
    for jj=1:ng
    for ii=1:ng
        fracInds(ii,jj) = sum(distyh(ytmattemp(:,jj)==ii,jj)) + ...
            sum(distyh(ytmattemp(:,jj)==ii+5,jj)).*( 0.2*ii- sum(distyh(ytmattemp<=ii))-sum(distyh(ytmattemp>5 & ytmattemp<ii+5 )))/sum(distyh(ytmattemp==ii+5));
         if (ii>1)
             fracInds(ii,jj) = fracInds(ii,jj) + ...
                 sum(distyh(ytmattemp(:,jj)==ii+4,jj)).*(1-( 0.2*(ii-1)- sum(distyh(ytmattemp<=ii-1))-sum(distyh(ytmattemp>5 & ytmattemp<ii+4 )))/sum(distyh(ytmattemp==ii+4)));
         end
         fracNHInds(ii,jj) = sum(distyh(ytmattemp(:,jj)==ii,jj).*FracSurvsEnterNHbyyh_l(ytmattemp(:,jj)==ii,jj) ) + ...
            sum(distyh(ytmattemp(:,jj)==ii+5,jj).*FracSurvsEnterNHbyyh_l(ytmattemp(:,jj)==ii+5,jj)).*( 0.2*ii- sum(distyh(ytmattemp<=ii))-sum(distyh(ytmattemp>5 & ytmattemp<ii+5 )))/sum(distyh(ytmattemp==ii+5));
         if (ii>1)
             fracNHInds(ii,jj) = fracNHInds(ii,jj) + ...
                 sum(distyh(ytmattemp(:,jj)==ii+4,jj).*FracSurvsEnterNHbyyh_l(ytmattemp(:,jj)==ii+4,jj)).*(1-( 0.2*(ii-1)- sum(distyh(ytmattemp<=ii-1))-sum(distyh(ytmattemp>5 & ytmattemp<ii+4 )))/sum(distyh(ytmattemp==ii+4)));
         end  
         %keyboard
    end
    end
    NHentrysurvsbyyhq_l= fracNHInds./fracInds;
    %fraction low types enter NH by income and frailty quintile. 
    NHentrysurvsbyyhq_l = NHentrysurvsbyyhq_l';       
    
    %Fraction high types who survive enter NH by income and frailty quintile both types
    FracSurvsEnterNHbyyh_h = sum(thetahmat.*distkappamat,3);
    fracInds = zeros(ng,ng);
    fracNHInds = zeros(ng,ng);
    for jj=1:ng
    for ii=1:ng
        fracInds(ii,jj) = sum(distyh(ytmattemp(:,jj)==ii,jj)) + ...
            sum(distyh(ytmattemp(:,jj)==ii+5,jj)).*( 0.2*ii- sum(distyh(ytmattemp<=ii))-sum(distyh(ytmattemp>5 & ytmattemp<ii+5 )))/sum(distyh(ytmattemp==ii+5));
         if (ii>1)
             fracInds(ii,jj) = fracInds(ii,jj) + ...
                 sum(distyh(ytmattemp(:,jj)==ii+4,jj)).*(1-( 0.2*(ii-1)- sum(distyh(ytmattemp<=ii-1))-sum(distyh(ytmattemp>5 & ytmattemp<ii+4 )))/sum(distyh(ytmattemp==ii+4)));
         end
         fracNHInds(ii,jj) = sum(distyh(ytmattemp(:,jj)==ii,jj).*FracSurvsEnterNHbyyh_h(ytmattemp(:,jj)==ii,jj) ) + ...
            sum(distyh(ytmattemp(:,jj)==ii+5,jj).*FracSurvsEnterNHbyyh_h(ytmattemp(:,jj)==ii+5,jj)).*( 0.2*ii- sum(distyh(ytmattemp<=ii))-sum(distyh(ytmattemp>5 & ytmattemp<ii+5 )))/sum(distyh(ytmattemp==ii+5));
         if (ii>1)
             fracNHInds(ii,jj) = fracNHInds(ii,jj) + ...
                 sum(distyh(ytmattemp(:,jj)==ii+4,jj).*FracSurvsEnterNHbyyh_h(ytmattemp(:,jj)==ii+4,jj)).*(1-( 0.2*(ii-1)- sum(distyh(ytmattemp<=ii-1))-sum(distyh(ytmattemp>5 & ytmattemp<ii+4 )))/sum(distyh(ytmattemp==ii+4)));
         end  
         %keyboard
    end
    end
    NHentrysurvsbyyhq_h= fracNHInds./fracInds;
    %fraction high types who survive enter NH by income and frailty quintile. 
    NHentrysurvsbyyhq_h = NHentrysurvsbyyhq_h';     
    
    
    
    %profits by income and frailty quintile
    fracInds = zeros(ng,ng);
    profitst = zeros(ng,ng);
    for jj=1:ng
    for ii=1:ng
        fracInds(ii,jj) = sum(distyh(ytmattemp(:,jj)==ii,jj)) + ...
            sum(distyh(ytmattemp(:,jj)==ii+5,jj)).*( 0.2*ii- sum(distyh(ytmattemp<=ii))-sum(distyh(ytmattemp>5 & ytmattemp<ii+5 )))/sum(distyh(ytmattemp==ii+5));
         if (ii>1)
             fracInds(ii,jj) = fracInds(ii,jj) + ...
                 sum(distyh(ytmattemp(:,jj)==ii+4,jj)).*(1-( 0.2*(ii-1)- sum(distyh(ytmattemp<=ii-1))-sum(distyh(ytmattemp>5 & ytmattemp<ii+4 )))/sum(distyh(ytmattemp==ii+4)));
         end
         profitst(ii,jj) = sum(distyh(ytmattemp(:,jj)==ii,jj).*profitsmat(ytmattemp(:,jj)==ii,jj) ) + ...
            sum(distyh(ytmattemp(:,jj)==ii+5,jj).*profitsmat(ytmattemp(:,jj)==ii+5,jj)).*( 0.2*ii- sum(distyh(ytmattemp<=ii))-sum(distyh(ytmattemp>5 & ytmattemp<ii+5 )))/sum(distyh(ytmattemp==ii+5));
         if (ii>1)
             profitst(ii,jj) = profitst(ii,jj) + ...
                 sum(distyh(ytmattemp(:,jj)==ii+4,jj).*profitsmat(ytmattemp(:,jj)==ii+4,jj)).*(1-( 0.2*(ii-1)- sum(distyh(ytmattemp<=ii-1))-sum(distyh(ytmattemp>5 & ytmattemp<ii+4 )))/sum(distyh(ytmattemp==ii+4)));
         end        
    end
    end
    profits_byyhq= profitst./fracInds;
    profits_byyhq = profits_byyhq';

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%5    
%% wealth moments
    wealthmat = (1+r)*asmat + lsmat*(1-tau) - tau*r*asmat;
    %calculate wealth distribution moments pre-kappa shock and pre-death event
    asvect = reshape(wealthmat,1,ny*nh);
    distyhvect = reshape(distyh,1,ny*nh);
    [asvect, ind_sort] = sort(asvect);
    distyhvect = distyhvect(ind_sort);
    ng = 5;
    as_mean = sum(asvect.*distyhvect);
    [as_qmeans,  as_shares, as_qvalues, as_cutoffs] = get_dist_stats(asvect, distyhvect, linspace(1/ng,1,ng));
    [as_pmeansBAD,  as_psharesBAD, as_pvalues, as_pcutoffs] = get_dist_stats(asvect, distyhvect, [0.5 0.9 0.95 0.99]);
    as_gini=get_gini(distyhvect,asvect);      
    [as_qrmeans,  as_qrshares, as_qrvalues, as_qrcutoffs] = get_dist_stats(asvect, distyhvect, linspace(1/4,1,4));
    
    asmattemp =zeros(ny,nh);
    for ii=ng:-1:1
        asmattemp( (wealthmat < as_qvalues(ii)) ) = ii;
        asmattemp(wealthmat==as_qvalues(ii)) = ii+5;
    end
    %asmattemp(58,5) = 4;
    
    %Fraction buy LTCI by wealth and frailty quintile both types
    fracInds = zeros(ng,ng);
    fracLTCIInds = zeros(ng,ng);
    for jj=1:ng
    for ii=1:ng
        fracInds(ii,jj) = sum(distyh(asmattemp(:,jj)==ii,jj)) + ...
            sum(distyh(asmattemp(:,jj)==ii+5,jj)).*( 0.2*ii- sum(distyh(asmattemp<=ii))-sum(distyh(asmattemp>5 & asmattemp<ii+5 )))/sum(distyh(asmattemp==ii+5));
         if (ii>1)
             fracInds(ii,jj) = fracInds(ii,jj) + ...
                 sum(distyh(asmattemp(:,jj)==ii+4,jj)).*(1-( 0.2*(ii-1)- sum(distyh(asmattemp<=ii-1))-sum(distyh(asmattemp>5 & asmattemp<ii+4 )))/sum(distyh(asmattemp==ii+4)));
         end
         fracLTCIInds(ii,jj) = sum(distyh(asmattemp(:,jj)==ii,jj).*FracLTCIbyyh(asmattemp(:,jj)==ii,jj) ) + ...
            sum(distyh(asmattemp(:,jj)==ii+5,jj).*FracLTCIbyyh(asmattemp(:,jj)==ii+5,jj)).*( 0.2*ii- sum(distyh(asmattemp<=ii))-sum(distyh(asmattemp>5 & asmattemp<ii+5 )))/sum(distyh(asmattemp==ii+5));
         if (ii>1)
             fracLTCIInds(ii,jj) = fracLTCIInds(ii,jj) + ...
                 sum(distyh(asmattemp(:,jj)==ii+4,jj).*FracLTCIbyyh(asmattemp(:,jj)==ii+4,jj)).*(1-( 0.2*(ii-1)- sum(distyh(asmattemp<=ii-1))-sum(distyh(asmattemp>5 & asmattemp<ii+4 )))/sum(distyh(asmattemp==ii+4)));
         end  
         %keyboard
    end
    end
    FracLTCIbyahq= fracLTCIInds./fracInds;
    %fraction LTCI by wealth and frailty quintile. 
    FracLTCIbyahq = FracLTCIbyahq';

    %%%Fraction of individuals in wealth Q1-3 who by LTCI by frailty
    %%%quintile
    FracLTCIbyahq_q1to3ave = sum(FracLTCIbyahq(:,1:3).*fracInds(:,1:3),2)./sum(fracInds(:,1:3),2);
    Weatlh1to3distbyhq = fracInds(:,1:3)./repmat(sum(fracInds(:,1:3),2),1,3);
    
    %Fraction buy LTCI by wealth and frailty quintile low types only
    fracInds = zeros(ng,ng);
    fracLTCIInds = zeros(ng,ng);
    for jj=1:ng
    for ii=1:ng
        fracInds(ii,jj) = sum(distyh(asmattemp(:,jj)==ii,jj)) + ...
            sum(distyh(asmattemp(:,jj)==ii+5,jj)).*( 0.2*ii- sum(distyh(asmattemp<=ii))-sum(distyh(asmattemp>5 & asmattemp<ii+5 )))/sum(distyh(asmattemp==ii+5));
         if (ii>1)
             fracInds(ii,jj) = fracInds(ii,jj) + ...
                 sum(distyh(asmattemp(:,jj)==ii+4,jj)).*(1-( 0.2*(ii-1)- sum(distyh(asmattemp<=ii-1))-sum(distyh(asmattemp>5 & asmattemp<ii+4 )))/sum(distyh(asmattemp==ii+4)));
         end
         fracLTCIInds(ii,jj) = sum(distyh(asmattemp(:,jj)==ii,jj).*FracLTCIlbyyh(asmattemp(:,jj)==ii,jj) ) + ...
            sum(distyh(asmattemp(:,jj)==ii+5,jj).*FracLTCIlbyyh(asmattemp(:,jj)==ii+5,jj)).*( 0.2*ii- sum(distyh(asmattemp<=ii))-sum(distyh(asmattemp>5 & asmattemp<ii+5 )))/sum(distyh(asmattemp==ii+5));
         if (ii>1)
             fracLTCIInds(ii,jj) = fracLTCIInds(ii,jj) + ...
                 sum(distyh(asmattemp(:,jj)==ii+4,jj).*FracLTCIlbyyh(asmattemp(:,jj)==ii+4,jj)).*(1-( 0.2*(ii-1)- sum(distyh(asmattemp<=ii-1))-sum(distyh(asmattemp>5 & asmattemp<ii+4 )))/sum(distyh(asmattemp==ii+4)));
         end        
    end
    end
    FracLTCIlbyahq= fracLTCIInds./fracInds./phimat(1,1);
    %fraction low types LTCI by wealth and frailty quintile. 
    FracLTCIlbyahq = FracLTCIlbyahq';   
    
    %Fraction buy LTCI by wealth and frailty quintile high types only
    fracInds = zeros(ng,ng);
    fracLTCIInds = zeros(ng,ng);
    for jj=1:ng
    for ii=1:ng
        fracInds(ii,jj) = sum(distyh(asmattemp(:,jj)==ii,jj)) + ...
            sum(distyh(asmattemp(:,jj)==ii+5,jj)).*( 0.2*ii- sum(distyh(asmattemp<=ii))-sum(distyh(asmattemp>5 & asmattemp<ii+5 )))/sum(distyh(asmattemp==ii+5));
         if (ii>1)
             fracInds(ii,jj) = fracInds(ii,jj) + ...
                 sum(distyh(asmattemp(:,jj)==ii+4,jj)).*(1-( 0.2*(ii-1)- sum(distyh(asmattemp<=ii-1))-sum(distyh(asmattemp>5 & asmattemp<ii+4 )))/sum(distyh(asmattemp==ii+4)));
         end
         fracLTCIInds(ii,jj) = sum(distyh(asmattemp(:,jj)==ii,jj).*FracLTCIhbyyh(asmattemp(:,jj)==ii,jj) ) + ...
            sum(distyh(asmattemp(:,jj)==ii+5,jj).*FracLTCIhbyyh(asmattemp(:,jj)==ii+5,jj)).*( 0.2*ii- sum(distyh(asmattemp<=ii))-sum(distyh(asmattemp>5 & asmattemp<ii+5 )))/sum(distyh(asmattemp==ii+5));
         if (ii>1)
             fracLTCIInds(ii,jj) = fracLTCIInds(ii,jj) + ...
                 sum(distyh(asmattemp(:,jj)==ii+4,jj).*FracLTCIhbyyh(asmattemp(:,jj)==ii+4,jj)).*(1-( 0.2*(ii-1)- sum(distyh(asmattemp<=ii-1))-sum(distyh(asmattemp>5 & asmattemp<ii+4 )))/sum(distyh(asmattemp==ii+4)));
         end        
    end
    end
    FracLTCIhbyahq= fracLTCIInds./fracInds./(1-phimat(1,1));
    %fraction high types LTCI by wealth and frailty quintile. 
    FracLTCIhbyahq = FracLTCIhbyahq';    
    
    %profits by wealth and frailty quintile
    fracInds = zeros(ng,ng);
    profitst = zeros(ng,ng);
    for jj=1:ng
    for ii=1:ng
        fracInds(ii,jj) = sum(distyh(asmattemp(:,jj)==ii,jj)) + ...
            sum(distyh(asmattemp(:,jj)==ii+5,jj)).*( 0.2*ii- sum(distyh(asmattemp<=ii))-sum(distyh(asmattemp>5 & asmattemp<ii+5 )))/sum(distyh(asmattemp==ii+5));
         if (ii>1)
             fracInds(ii,jj) = fracInds(ii,jj) + ...
                 sum(distyh(asmattemp(:,jj)==ii+4,jj)).*(1-( 0.2*(ii-1)- sum(distyh(asmattemp<=ii-1))-sum(distyh(asmattemp>5 & asmattemp<ii+4 )))/sum(distyh(asmattemp==ii+4)));
         end
         profitst(ii,jj) = sum(distyh(asmattemp(:,jj)==ii,jj).*profitsmat(asmattemp(:,jj)==ii,jj) ) + ...
            sum(distyh(asmattemp(:,jj)==ii+5,jj).*profitsmat(asmattemp(:,jj)==ii+5,jj)).*( 0.2*ii- sum(distyh(asmattemp<=ii))-sum(distyh(asmattemp>5 & asmattemp<ii+5 )))/sum(distyh(asmattemp==ii+5));
         if (ii>1)
             profitst(ii,jj) = profitst(ii,jj) + ...
                 sum(distyh(asmattemp(:,jj)==ii+4,jj).*profitsmat(asmattemp(:,jj)==ii+4,jj)).*(1-( 0.2*(ii-1)- sum(distyh(asmattemp<=ii-1))-sum(distyh(asmattemp>5 & asmattemp<ii+4 )))/sum(distyh(asmattemp==ii+4)));
         end        
    end
    end
    Profitsbyahq= profitst./fracInds;
    Profitsbyahq = Profitsbyahq';
        
    clear asvect;
    
    NHprobvect = reshape( ((survprobslmat.*sum(thetalmat.*distkappamat,3).*phimat + survprobshmat.*sum(thetahmat.*distkappamat,3).*(1-phimat))),1,ny*nh);
    NHprobvect = NHprobvect(ind_sort);
    NHprobvect2 = reshape( ((survprobslmat.*sum(thetalmat.^2.*distkappamat,3).*phimat + survprobshmat.*sum(thetahmat.^2.*distkappamat,3).*(1-phimat))),1,ny*nh);
    NHprobvect2 = NHprobvect2(ind_sort);
    [NHentry_byasq_means,  NHentry_byasq_shares] = get_dist_stats_x(NHprobvect, distyhvect, as_cutoffs, ng);   
    [NHentry2_byasq_means,  NHentry2_byasq_shares] = get_dist_stats_x(NHprobvect2, distyhvect, as_cutoffs, ng);
    
    VarNHentry_byasq = NHentry2_byasq_means-(NHentry_byasq_means).^2;
    
    
    FracSurvsNHvect1 = reshape( FracSurvsEnterNHbyyh,1,ny*nh);
    FracSurvsNHvect1 = FracSurvsNHvect1(ind_sort);
    FracSurvsNHvect2 = reshape( FracSurvsEnterNH2byyh,1,ny*nh);
    FracSurvsNHvect2 = FracSurvsNHvect2(ind_sort);    
    [NHentrysurvs_byasq_means,  NHentrysurvs_byasq_shares] = get_dist_stats_x(FracSurvsNHvect1, distyhvect, as_cutoffs, ng);  
    [NHentry2survs_byasq_means,  NHentry2survs_byasq_shares] = get_dist_stats_x(FracSurvsNHvect2, distyhvect, as_cutoffs, ng);
    
    VarNHentrysurvs_byasq = NHentry2survs_byasq_means-(NHentrysurvs_byasq_means).^2;
    
    FracLTCIvect1 = reshape( FracLTCIbyyh,1,ny*nh);
    FracLTCIvect1 = FracLTCIvect1(ind_sort);
    [FracLTCI_byasq_means,  FracLTCI_byasq_shares] = get_dist_stats_x(FracLTCIvect1, distyhvect, as_cutoffs, ng);  
    
    %%%
    FracInsEnterNH_mean = sum(sum(FracEnterNHbyyh_l.*FracLTCIlbyyh.*distyh))./FracLTCIl + sum(sum(FracEnterNHbyyh_h.*FracLTCIhbyyh.*distyh))./FracLTCIh;
    FracUninsEnterNH_mean = sum(sum(FracEnterNHbyyh_l.*(phimat-FracLTCIlbyyh).*distyh))./(1-FracLTCIl) ...
        + sum(sum(FracEnterNHbyyh_h.*(1-phimat-FracLTCIhbyyh).*distyh))./(1-FracLTCIh);

    FracInsEnterNH2_mean = sum(sum(FracEnterNH2byyh_l.*FracLTCIlbyyh.*distyh))./FracLTCIl + sum(sum(FracEnterNH2byyh_h.*FracLTCIhbyyh.*distyh))./FracLTCIh;
    FracUninsEnterNH2_mean = sum(sum(FracEnterNH2byyh_l.*(phimat-FracLTCIlbyyh).*distyh))./(1-FracLTCIl) ...
        + sum(sum(FracEnterNH2byyh_h.*(1-phimat-FracLTCIhbyyh).*distyh))./(1-FracLTCIh);
    
    VarNHentryIns = FracInsEnterNH2_mean-(FracInsEnterNH_mean).^2;
    VarNHentryUnins = FracUninsEnterNH2_mean-(FracUninsEnterNH_mean).^2;
    
    FracInsSurvsEnterNH_mean = sum(sum(FracSurvsEnterNHbyyh_l.*FracLTCIlbyyh.*distyh))./FracLTCIl + sum(sum(FracSurvsEnterNHbyyh_h.*FracLTCIhbyyh.*distyh))./FracLTCIh;
    FracUninsSurvsEnterNH_mean = sum(sum(FracSurvsEnterNHbyyh_l.*(phimat-FracLTCIlbyyh).*distyh))./(1-FracLTCIl) ...
        + sum(sum(FracSurvsEnterNHbyyh_h.*(1-phimat-FracLTCIhbyyh).*distyh))./(1-FracLTCIh);

    FracInsSurvsEnterNH2_mean = sum(sum(FracSurvsEnterNH2byyh_l.*FracLTCIlbyyh.*distyh))./FracLTCIl + sum(sum(FracSurvsEnterNH2byyh_h.*FracLTCIhbyyh.*distyh))./FracLTCIh;
    FracUninsSurvsEnterNH2_mean = sum(sum(FracSurvsEnterNH2byyh_l.*(phimat-FracLTCIlbyyh).*distyh))./(1-FracLTCIl) ...
        + sum(sum(FracSurvsEnterNH2byyh_h.*(1-phimat-FracLTCIhbyyh).*distyh))./(1-FracLTCIh);
    
    VarNHentrySurvsIns = FracInsSurvsEnterNH2_mean-(FracInsSurvsEnterNH_mean).^2;
    VarNHentrySurvsUnins = FracUninsSurvsEnterNH2_mean-(FracUninsSurvsEnterNH_mean).^2;    
    
    %%%%%
    FracLTCIvect1 = reshape( tlsmat>0,1,ny*nh);
    FracLTCIvect1 = FracLTCIvect1(ind_sort);
    [FracLTCIl_byasq_means,  FracLTCIl_byasq_shares] = get_dist_stats_x(FracLTCIvect1, distyhvect, as_cutoffs, ng);  
   
    FracLTCIvect1 = reshape( thsmat>0,1,ny*nh);
    FracLTCIvect1 = FracLTCIvect1(ind_sort);
    [FracLTCIh_byasq_means,  FracLTCIh_byasq_shares] = get_dist_stats_x(FracLTCIvect1, distyhvect, as_cutoffs, ng);    
   
    
    %Fraction rejected 
    NumRejectedbyyh = NumRejectedMTSIbyyh + NumRejectedNoMTSIbyyh;
    FracRejectedvect1 = reshape( NumRejectedbyyh,1,ny*nh);
    FracRejectedvect1 = FracRejectedvect1(ind_sort);
    [FracRejected_byasq_means,  FracRejected_byasq_shares] = get_dist_stats_x(FracRejectedvect1, distyhvect, as_cutoffs, ng);  
    FracRejectedvect1 = reshape( NumRejectedMTSIbyyh,1,ny*nh);
    FracRejectedvect1 = FracRejectedvect1(ind_sort);
    [FracRejectedMTSI_byasq_means,  FracRejectedMTSI_byasq_shares] = get_dist_stats_x(FracRejectedvect1, distyhvect, as_cutoffs, ng);  
    FracRejectedvect1 = reshape( NumRejectedNoMTSIbyyh,1,ny*nh);
    FracRejectedvect1 = FracRejectedvect1(ind_sort);
    [FracRejectedNoMTSI_byasq_means,  FracRejectedNoMTSI_byasq_shares] = get_dist_stats_x(FracRejectedvect1, distyhvect, as_cutoffs, ng);  

    %Fraction rejected by wealth and frailty quintile both types
    fracInds = zeros(ng,ng);
    fracRejInds = zeros(ng,ng);
    for jj=1:ng
    for ii=1:ng
        fracInds(ii,jj) = sum(distyh(asmattemp(:,jj)==ii,jj)) + ...
            sum(distyh(asmattemp(:,jj)==ii+5,jj)).*( 0.2*ii- sum(distyh(asmattemp<=ii))-sum(distyh(asmattemp>5 & asmattemp<ii+5 )))/sum(distyh(asmattemp==ii+5));
         if (ii>1)
             fracInds(ii,jj) = fracInds(ii,jj) + ...
                 sum(distyh(asmattemp(:,jj)==ii+4,jj)).*(1-( 0.2*(ii-1)- sum(distyh(asmattemp<=ii-1))-sum(distyh(asmattemp>5 & asmattemp<ii+4 )))/sum(distyh(asmattemp==ii+4)));
         end
         fracRejInds(ii,jj) = sum(distyh(asmattemp(:,jj)==ii,jj).*NumRejectedbyyh(asmattemp(:,jj)==ii,jj) ) + ...
            sum(distyh(asmattemp(:,jj)==ii+5,jj).*NumRejectedbyyh(asmattemp(:,jj)==ii+5,jj)).*( 0.2*ii- sum(distyh(asmattemp<=ii))-sum(distyh(asmattemp>5 & asmattemp<ii+5 )))/sum(distyh(asmattemp==ii+5));
         if (ii>1)
             fracRejInds(ii,jj) = fracRejInds(ii,jj) + ...
                 sum(distyh(asmattemp(:,jj)==ii+4,jj).*NumRejectedbyyh(asmattemp(:,jj)==ii+4,jj)).*(1-( 0.2*(ii-1)- sum(distyh(asmattemp<=ii-1))-sum(distyh(asmattemp>5 & asmattemp<ii+4 )))/sum(distyh(asmattemp==ii+4)));
         end        
    end
    end
    FracRejectedbyahq= fracRejInds./fracInds;
    %fraction rejected by wealth and frailty quintile. 
    FracRejectedbyahq = FracRejectedbyahq';


    FracSurvvect1 = reshape( FracSurvbyyh,1,ny*nh);
    FracSurvvect1 = FracSurvvect1(ind_sort);
    [survs_byasq_means,  survs_byasq_shares] = get_dist_stats_x(FracSurvvect1, distyhvect, as_cutoffs, ng);  
        
    NumUseLTCIvect1 = reshape( NumUseLTCIbyyh,1,ny*nh);
    NumUseLTCIvect1 = NumUseLTCIvect1(ind_sort);    
    [FracNHuseLTCI_byasq_means,  FracNHuseLTCI_byasq_shares] = get_dist_stats_x(NumUseLTCIvect1, distyhvect, as_cutoffs, ng);     
    FracNHuseLTCI_byasq_means = FracNHuseLTCI_byasq_means./NHentry_byasq_means;
    NumNonNHLTCIvect1 = reshape( NumNonNHLTCIbyyh,1,ny*nh);
    NumNonNHLTCIvect1 = NumNonNHLTCIvect1(ind_sort);        
    [FracNonNHuseLTCI_byasq_means,  FracNonNHuseLTCI_byasq_shares] = get_dist_stats_x(NumNonNHLTCIvect1, distyhvect, as_cutoffs, ng);
    FracNonNHuseLTCI_byasq_means = FracNonNHuseLTCI_byasq_means./(survs_byasq_means- NHentry_byasq_means);
    
    %%%%%
    NumSurvsLTCINHbyyh = phimat.*(tlsmat>0).*NHentrybyyh_l + (1-phimat).*(thsmat>0).*NHentrybyyh_h;
    NumSurvsLTCIbyyh = survprobslmat.*phimat.*(tlsmat>0) + survprobshmat.*(1-phimat).*(thsmat>0);
    NumSurvsLTCINHvect1 = reshape( NumSurvsLTCINHbyyh,1,ny*nh);
    NumSurvsLTCINHvect1 = NumSurvsLTCINHvect1(ind_sort);    
    NumSurvsLTCIvect1 = reshape( NumSurvsLTCIbyyh,1,ny*nh);
    NumSurvsLTCIvect1 = NumSurvsLTCIvect1(ind_sort);     
    [FracLTCsurvswhoEnterNHn_byasq_means,  FracLTCsurvswhoEnterNH_byasq_shares] = get_dist_stats_x(NumSurvsLTCINHvect1, distyhvect, as_cutoffs, ng);
    [FracLTCsurvs_byasq_means,  FracLTCsurvs_byasq_shares] = get_dist_stats_x(NumSurvsLTCIvect1, distyhvect, as_cutoffs, ng);
    FracLTCsurvswhoEnterNH_byasq_means = FracLTCsurvswhoEnterNHn_byasq_means./FracLTCsurvs_byasq_means;
    
    NumSurvsNoLTCINHbyyh = phimat.*(tlsmat==0).*NHentrybyyh_l + (1-phimat).*(thsmat==0).*NHentrybyyh_h;
    NumSurvsNoLTCIbyyh = survprobslmat.*phimat.*(tlsmat==0) + survprobshmat.*(1-phimat).*(thsmat==0);
    NumSurvsNoLTCINHvect1 = reshape( NumSurvsNoLTCINHbyyh,1,ny*nh);
    NumSurvsNoLTCINHvect1 = NumSurvsNoLTCINHvect1(ind_sort);    
    NumSurvsNoLTCIvect1 = reshape( NumSurvsNoLTCIbyyh,1,ny*nh);
    NumSurvsNoLTCIvect1 = NumSurvsNoLTCIvect1(ind_sort);     
    [FracNonLTCsurvswhoEnterNHn_byasq_means,  FracNonLTCsurvswhoEnterNH_byasq_shares] = get_dist_stats_x(NumSurvsNoLTCINHvect1, distyhvect, as_cutoffs, ng);
    [FracNonLTCsurvs_byasq_means,  FracNonLTCsurvs_byasq_shares] = get_dist_stats_x(NumSurvsNoLTCIvect1, distyhvect, as_cutoffs, ng);
    FracNonLTCsurvswhoEnterNH_byasq_means = FracNonLTCsurvswhoEnterNHn_byasq_means./FracNonLTCsurvs_byasq_means;        
    
    NumIndsLTCIbyyh = phimat.*(tlsmat>0) + (1-phimat).*(thsmat>0);  
    NumIndsLTCIvect1 = reshape( NumIndsLTCIbyyh,1,ny*nh);
    NumIndsLTCIvect1 = NumIndsLTCIvect1(ind_sort);     
    [FracLTCinds_byasq_means,  FracLTCinds_byasq_shares] = get_dist_stats_x(NumIndsLTCIvect1, distyhvect, as_cutoffs, ng);
    FracLTCindswhoEnterNH_byasq_means = FracLTCsurvswhoEnterNHn_byasq_means./FracLTCinds_byasq_means;
      
    NumIndsNoLTCIbyyh = phimat.*(tlsmat==0) + (1-phimat).*(thsmat==0);  
    NumIndsNoLTCIvect1 = reshape( NumIndsNoLTCIbyyh,1,ny*nh);
    NumIndsNoLTCIvect1 = NumIndsNoLTCIvect1(ind_sort);     
    [FracNonLTCinds_byasq_means,  FracNonLTCinds_byasq_shares] = get_dist_stats_x(NumIndsNoLTCIvect1, distyhvect, as_cutoffs, ng);
    FracNonLTCindswhoEnterNH_byasq_means = FracNonLTCsurvswhoEnterNHn_byasq_means./FracNonLTCinds_byasq_means;        
    %%%%%%
    
    Premiavect1 = reshape( Premiabyyh,1,ny*nh);
    Premiavect1 = Premiavect1(ind_sort);     
    [Premia_byasq_means,  Premia_byasq_shares] = get_dist_stats_x(Premiavect1, distyhvect, as_cutoffs, ng);
    Premia_byasq_means = Premia_byasq_means./FracLTCI_byasq_means;     
    
    Premiavect1 = reshape( thsmat,1,ny*nh);
    Premiavect1 = Premiavect1(ind_sort);    
    [Premiah_byasq_means,  Premiah_byasq_shares] = get_dist_stats_x(Premiavect1, distyhvect, as_cutoffs, ng);
    Premiah_byasq_means = Premiah_byasq_means./FracLTCIh_byasq_means; 
    Premiavect1 = reshape( tlsmat,1,ny*nh);
    Premiavect1 = Premiavect1(ind_sort);      
    [Premial_byasq_means,  Premial_byasq_shares] = get_dist_stats_x(Premiavect1, distyhvect, as_cutoffs, ng);
    Premial_byasq_means = Premial_byasq_means./FracLTCIl_byasq_means;      
    
    loadsvect1 = reshape( loadsbyyh,1,ny*nh);
    loadsvect1 = loadsvect1(ind_sort);     
    [loads_byasq_means,  loads_byasq_shares] = get_dist_stats_x(loadsvect1, distyhvect, as_cutoffs, ng);
    loads_byasq_means = loads_byasq_means./FracLTCI_byasq_means;       

    loadsvect1 = reshape( loadhmat,1,ny*nh);
    loadsvect1 = loadsvect1(ind_sort);    
    [loadh_byasq_means,  loadh_byasq_shares] = get_dist_stats_x(loadsvect1, distyhvect, as_cutoffs, ng);
    loadh_byasq_means = loadh_byasq_means./FracLTCIh_byasq_means; 
    loadsvect1 = reshape( loadlmat,1,ny*nh);
    loadsvect1 = loadsvect1(ind_sort);      
    [loadl_byasq_means,  loadl_byasq_shares] = get_dist_stats_x(loadsvect1, distyhvect, as_cutoffs, ng);
    loadl_byasq_means = loadl_byasq_means./FracLTCIl_byasq_means;      

    
    
    
    FracCoveredvect1 = reshape( FracCoveredbyyh,1,ny*nh);
    FracCoveredvect1 = FracCoveredvect1(ind_sort);     
    [FracCovered_byasq_means,  FracCovered_byasq_shares] = get_dist_stats_x(FracCoveredvect1, distyhvect, as_cutoffs, ng);
    FracCovered_byasq_means = FracCovered_byasq_means./FracLTCI_byasq_means;       

    FracCoveredvect1 = reshape( fracCoveredlmat,1,ny*nh);
    FracCoveredvect1 = FracCoveredvect1(ind_sort);     
    [FracCoveredl_byasq_means,  FracCoveredl_byasq_shares] = get_dist_stats_x(FracCoveredvect1, distyhvect, as_cutoffs, ng);
    FracCoveredl_byasq_means = FracCoveredl_byasq_means./FracLTCIl_byasq_means;       
    
    FracCoveredvect1 = reshape( fracCoveredhmat,1,ny*nh);
    FracCoveredvect1 = FracCoveredvect1(ind_sort);     
    [FracCoveredh_byasq_means,  FracCoveredh_byasq_shares] = get_dist_stats_x(FracCoveredvect1, distyhvect, as_cutoffs, ng);
    FracCoveredh_byasq_means = FracCoveredh_byasq_means./FracLTCIh_byasq_means;       

    
    clear distyhvect;
    
    %calculate post-kappa shock and post-death even wealth distribution moments
    postaslvect = reshape(postaslmat,1,ny*nh*nk); 
    postashvect = reshape(postashmat,1,ny*nh*nk); 
    distyhkappal = repmat(distyh.*phimat.*survprobslmat./FracSurv,1,1,nk).*repmat(reshape(distkappa,1,1,nk),ny,nh,1);
    distyhkappah = repmat(distyh.*(1-phimat).*survprobshmat./FracSurv,1,1,nk).*repmat(reshape(distkappa,1,1,nk),ny,nh,1);
    distyhkappalvect = reshape(distyhkappal,1,ny*nh*nk); 
    distyhkappahvect = reshape(distyhkappah,1,ny*nh*nk); 
    postasvect = [postaslvect postashvect];
    distyhkappavect = [distyhkappalvect distyhkappahvect];
    [postasvect, ind_sort] = sort(postasvect);
    distyhkappavect = distyhkappavect(ind_sort);
    ng = 5;
    postas_mean = sum(postasvect.*distyhkappavect);
    [postas_qmeans,  postas_shares, postas_qvalues, postas_cutoffs] = get_dist_stats(postasvect, distyhkappavect, linspace(1/ng,1,ng));  
    [postas_pmeansBAD,  postas_psharesBAD, postas_pvalues, postas_pcutoffs] = get_dist_stats(postasvect, distyhkappavect, [0.5 0.9 0.95 0.99]);
    postas_gini=get_gini(distyhkappavect,postasvect);      
        
    %calculate post-kappa shock wealth distribution moments of NH entrants only
    %distyhkappal = distyhkappal.*thetalmat/FracSurvsEnterNH;
    distyhkappal = repmat(distyh.*survprobslmat.*phimat,1,1,nk).*thetalmat.*repmat(reshape(distkappa,1,1,nk),ny,nh,1)/FracEnterNH;
    distyhkappah = repmat(distyh.*survprobshmat.*(1-phimat),1,1,nk).*thetahmat.*repmat(reshape(distkappa,1,1,nk),ny,nh,1)/FracEnterNH;    
    %distyhkappah = distyhkappah.*thetahmat/FracSurvsEnterNH;
    distyhkappalvect = reshape(distyhkappal,1,ny*nh*nk); 
    distyhkappahvect = reshape(distyhkappah,1,ny*nh*nk);     
    distyhkappavect = [distyhkappalvect distyhkappahvect];
    distyhkappavect = distyhkappavect(ind_sort);
    ng = 5;
    postasNH_mean = sum(postasvect.*distyhkappavect);
    [postasNH_qmeans,  postasNH_shares, postasNH_qvalues, postasNH_cutoffs] = get_dist_stats(postasvect, distyhkappavect, linspace(1/ng,1,ng));  
    [postasNH_pmeansBAD,  postasNH_psharesBAD, postasNH_pvalues, postasNH_pcutoffs] = get_dist_stats(postasvect, distyhkappavect, [0.5 0.9 0.95 0.99]);
    postasNH_gini=get_gini(distyhkappavect,postasvect);      
    
    %calculate joint frailty/wealth distribution moments
    %wealth moments for each frailty point    
    as_qmeans_byh = zeros(nh,ng);
    as_shares_byh = zeros(nh,ng);
    as_qvalues_byh = zeros(nh,ng);
    as_cutoffs_byh = zeros(nh,ng);
    for i=1:nh
        [asvect, ind_sort] = sort(wealthmat(:,nh-i+1)');
        distyhvect = distyh(:,nh-i+1)'./disth(nh-i+1);
        distyhvect = distyhvect(ind_sort);
        [as_qmeans_byh(i,:),  as_shares_byh(i,:), as_qvalues_byh(i,:), as_cutoffs_byh(i,:)] = get_dist_stats(asvect, distyhvect, linspace(1/ng,1,ng)); 
    end
    
    %wealth moments for each frailty quintile 
    [as_qmeans_byhq,  as_shares_byhq, as_qvalues_byhq,  as_cutoffs_byhq] = get_dist_stats_jointx(wealthmat, distyh, ...
        phi_cutoffs, disth, ng); 

    %wealth moments for each frailty quartile 
    %[phi_qmeans2,  phi_shares2, phi_qvalues2, phi_cutoffs2] = get_dist_stats(fliplr(1-phigrid), fliplr(disth), linspace(1/4,1,4));
    [as_qmeans_byhqr,  as_shares_byhqr, as_qvalues_byhqr,  as_cutoffs_byhqr] = get_dist_stats_jointx(wealthmat, distyh, ...
        phi_cutoffs2, disth, 4); 
   
    ngw = 4;
    asmattemp =zeros(ny,nh);
    for ii=ngw:-1:1
        asmattemp( (wealthmat < as_qrvalues(ii)) ) = ii;
        asmattemp(wealthmat==as_qrvalues(ii)) = ii+ngw;
    end    
    
    %Fraction buy LTCI by wealth quartile and frailty quintile high types only
    fracInds = zeros(ngw,ng);
    fracLTCIInds = zeros(ngw,ng);
    for jj=1:ng
    for ii=1:ngw
        fracInds(ii,jj) = sum(distyh(asmattemp(:,jj)==ii,jj)) + ...
            sum(distyh(asmattemp(:,jj)==ii+ngw,jj)).*( 0.25*ii- sum(distyh(asmattemp<=ii))-sum(distyh(asmattemp>ngw & asmattemp<ii+ngw )))/sum(distyh(asmattemp==ii+ngw));
         if (ii>1)
             fracInds(ii,jj) = fracInds(ii,jj) + ...
                 sum(distyh(asmattemp(:,jj)==ii+ngw-1,jj)).*(1-( 0.25*(ii-1)- sum(distyh(asmattemp<=ii-1))-sum(distyh(asmattemp>ngw & asmattemp<ii+ngw-1 )))/sum(distyh(asmattemp==ii+ngw-1)));
         end
         fracLTCIInds(ii,jj) = sum(distyh(asmattemp(:,jj)==ii,jj).*FracLTCIhbyyh(asmattemp(:,jj)==ii,jj) ) + ...
            sum(distyh(asmattemp(:,jj)==ii+ngw,jj).*FracLTCIhbyyh(asmattemp(:,jj)==ii+ngw,jj)).*( 0.25*ii- sum(distyh(asmattemp<=ii))-sum(distyh(asmattemp>ngw & asmattemp<ii+ngw )))/sum(distyh(asmattemp==ii+ngw));
         if (ii>1)
             fracLTCIInds(ii,jj) = fracLTCIInds(ii,jj) + ...
                 sum(distyh(asmattemp(:,jj)==ii+ngw-1,jj).*FracLTCIhbyyh(asmattemp(:,jj)==ii+ngw-1,jj)).*(1-( 0.25*(ii-1)- sum(distyh(asmattemp<=ii-1))-sum(distyh(asmattemp>ngw & asmattemp<ii+ngw-1 )))/sum(distyh(asmattemp==ii+ngw-1)));
         end        
    end
    end
    FracLTCIhbyahqr= fracLTCIInds./fracInds./(1-phimat(1,1));
    %fraction high types LTCI by wealth quartile and frailty quintile. 
    FracLTCIhbyahqr = FracLTCIhbyahqr';    
    
    %Fraction buy LTCI by wealth quartile and frailty quintile low types only
    fracInds = zeros(ngw,ng);
    fracLTCIInds = zeros(ngw,ng);
    for jj=1:ng
    for ii=1:ngw
        fracInds(ii,jj) = sum(distyh(asmattemp(:,jj)==ii,jj)) + ...
            sum(distyh(asmattemp(:,jj)==ii+ngw,jj)).*( 0.25*ii- sum(distyh(asmattemp<=ii))-sum(distyh(asmattemp>ngw & asmattemp<ii+ngw )))/sum(distyh(asmattemp==ii+ngw));
         if (ii>1)
             fracInds(ii,jj) = fracInds(ii,jj) + ...
                 sum(distyh(asmattemp(:,jj)==ii+ngw-1,jj)).*(1-( 0.25*(ii-1)- sum(distyh(asmattemp<=ii-1))-sum(distyh(asmattemp>ngw & asmattemp<ii+ngw-1 )))/sum(distyh(asmattemp==ii+ngw-1)));
         end
         fracLTCIInds(ii,jj) = sum(distyh(asmattemp(:,jj)==ii,jj).*FracLTCIlbyyh(asmattemp(:,jj)==ii,jj) ) + ...
            sum(distyh(asmattemp(:,jj)==ii+ngw,jj).*FracLTCIlbyyh(asmattemp(:,jj)==ii+ngw,jj)).*( 0.25*ii- sum(distyh(asmattemp<=ii))-sum(distyh(asmattemp>ngw & asmattemp<ii+ngw )))/sum(distyh(asmattemp==ii+ngw));
         if (ii>1)
             fracLTCIInds(ii,jj) = fracLTCIInds(ii,jj) + ...
                 sum(distyh(asmattemp(:,jj)==ii+ngw-1,jj).*FracLTCIlbyyh(asmattemp(:,jj)==ii+ngw-1,jj)).*(1-( 0.25*(ii-1)- sum(distyh(asmattemp<=ii-1))-sum(distyh(asmattemp>ngw & asmattemp<ii+ngw-1 )))/sum(distyh(asmattemp==ii+ngw-1)));
         end        
    end
    end
    FracLTCIlbyahqr= fracLTCIInds./fracInds./(phimat(1,1));
    %fraction low types LTCI by wealth quartile and frailty quintile. 
    FracLTCIlbyahqr = FracLTCIlbyahqr';      
    
    %Fraction survivors LTCI by wealth quartile and frailty quintile high types only
    fracInds = zeros(ngw,ng);
    fracLTCIInds = zeros(ngw,ng);
    for jj=1:ng
    for ii=1:ngw
        fracInds(ii,jj) = sum((1-phimat(asmattemp(:,jj)==ii,jj)).*survprobshmat(asmattemp(:,jj)==ii,jj).*distyh(asmattemp(:,jj)==ii,jj)) + ...
            sum((1-phimat(asmattemp(:,jj)==ii+ngw,jj)).*survprobshmat(asmattemp(:,jj)==ii+ngw,jj).*distyh(asmattemp(:,jj)==ii+ngw,jj)).*( 0.25*ii- sum(distyh(asmattemp<=ii))-sum(distyh(asmattemp>ngw & asmattemp<ii+ngw )))/sum(distyh(asmattemp==ii+ngw));
         if (ii>1)
             fracInds(ii,jj) = fracInds(ii,jj) + ...
                 sum((1-phimat(asmattemp(:,jj)==ii+ngw-1,jj)).*survprobshmat(asmattemp(:,jj)==ii+ngw-1,jj).*distyh(asmattemp(:,jj)==ii+ngw-1,jj)).*(1-( 0.25*(ii-1)- sum(distyh(asmattemp<=ii-1))-sum(distyh(asmattemp>ngw & asmattemp<ii+ngw-1 )))/sum(distyh(asmattemp==ii+ngw-1)));
         end
         fracLTCIInds(ii,jj) = sum(distyh(asmattemp(:,jj)==ii,jj).*FracSurvsLTCIhbyyh(asmattemp(:,jj)==ii,jj) ) + ...
            sum(distyh(asmattemp(:,jj)==ii+ngw,jj).*FracSurvsLTCIhbyyh(asmattemp(:,jj)==ii+ngw,jj)).*( 0.25*ii- sum(distyh(asmattemp<=ii))-sum(distyh(asmattemp>ngw & asmattemp<ii+ngw )))/sum(distyh(asmattemp==ii+ngw));
         if (ii>1)
             fracLTCIInds(ii,jj) = fracLTCIInds(ii,jj) + ...
                 sum(distyh(asmattemp(:,jj)==ii+ngw-1,jj).*FracSurvsLTCIhbyyh(asmattemp(:,jj)==ii+ngw-1,jj)).*(1-( 0.25*(ii-1)- sum(distyh(asmattemp<=ii-1))-sum(distyh(asmattemp>ngw & asmattemp<ii+ngw-1 )))/sum(distyh(asmattemp==ii+ngw-1)));
         end        
    end
    end
    FracSurvsLTCIhbyahqr= fracLTCIInds./fracInds;
    %fraction high types survivors LTCI by wealth quartile and frailty quintile. 
    FracSurvsLTCIhbyahqr = FracSurvsLTCIhbyahqr';    
    
    %Fraction survivors with LTCI by wealth quartile and frailty quintile low types only
    fracInds = zeros(ngw,ng);
    fracLTCIInds = zeros(ngw,ng);
    for jj=1:ng
    for ii=1:ngw
        fracInds(ii,jj) = sum(phimat(asmattemp(:,jj)==ii,jj).*survprobslmat(asmattemp(:,jj)==ii,jj).*distyh(asmattemp(:,jj)==ii,jj)) + ...
            sum(phimat(asmattemp(:,jj)==ii+ngw,jj).*survprobslmat(asmattemp(:,jj)==ii+ngw,jj).*distyh(asmattemp(:,jj)==ii+ngw,jj)).*( 0.25*ii- sum(distyh(asmattemp<=ii))-sum(distyh(asmattemp>ngw & asmattemp<ii+ngw )))/sum(distyh(asmattemp==ii+ngw));
         if (ii>1)
             fracInds(ii,jj) = fracInds(ii,jj) + ...
                 sum(phimat(asmattemp(:,jj)==ii+ngw-1,jj).*survprobslmat(asmattemp(:,jj)==ii+ngw-1,jj).*distyh(asmattemp(:,jj)==ii+ngw-1,jj)).*(1-( 0.25*(ii-1)- sum(distyh(asmattemp<=ii-1))-sum(distyh(asmattemp>ngw & asmattemp<ii+ngw-1 )))/sum(distyh(asmattemp==ii+ngw-1)));
         end
         fracLTCIInds(ii,jj) = sum(distyh(asmattemp(:,jj)==ii,jj).*FracSurvsLTCIlbyyh(asmattemp(:,jj)==ii,jj) ) + ...
            sum(distyh(asmattemp(:,jj)==ii+ngw,jj).*FracSurvsLTCIlbyyh(asmattemp(:,jj)==ii+ngw,jj)).*( 0.25*ii- sum(distyh(asmattemp<=ii))-sum(distyh(asmattemp>ngw & asmattemp<ii+ngw )))/sum(distyh(asmattemp==ii+ngw));
         if (ii>1)
             fracLTCIInds(ii,jj) = fracLTCIInds(ii,jj) + ...
                 sum(distyh(asmattemp(:,jj)==ii+ngw-1,jj).*FracSurvsLTCIlbyyh(asmattemp(:,jj)==ii+ngw-1,jj)).*(1-( 0.25*(ii-1)- sum(distyh(asmattemp<=ii-1))-sum(distyh(asmattemp>ngw & asmattemp<ii+ngw-1 )))/sum(distyh(asmattemp==ii+ngw-1)));
         end        
    end
    end
    FracSurvsLTCIlbyahqr= fracLTCIInds./fracInds;
    %fraction low types survivors LTCI by wealth quartile and frailty quintile. 
    FracSurvsLTCIlbyahqr = FracSurvsLTCIlbyahqr';         
    
    
    %Fraction survivors with LTCI who enter NH by wealth quartile and frailty quintile
    fracInds = zeros(ngw,ng);
    fracLTCIInds = zeros(ngw,ng);
    for jj=1:ng
    for ii=1:ngw
        fracInds(ii,jj) = sum(NumSurvsLTCIbyyh(asmattemp(:,jj)==ii,jj).*distyh(asmattemp(:,jj)==ii,jj)) + ...
            sum(NumSurvsLTCIbyyh(asmattemp(:,jj)==ii+ngw,jj).*distyh(asmattemp(:,jj)==ii+ngw,jj)).*( 0.25*ii- sum(distyh(asmattemp<=ii))...
            -sum(distyh(asmattemp>ngw & asmattemp<ii+ngw )))/sum(distyh(asmattemp==ii+ngw));  
         if (ii>1)
             fracInds(ii,jj) = fracInds(ii,jj) + ...
                 sum(distyh(asmattemp(:,jj)==ii+ngw-1,jj).*NumSurvsLTCIbyyh(asmattemp(:,jj)==ii+ngw-1,jj)).*(1-( 0.25*(ii-1)- sum(distyh(asmattemp<=ii-1))-sum(distyh(asmattemp>ngw & asmattemp<ii+ngw-1 )))/sum(distyh(asmattemp==ii+ngw-1)));
         end
         fracLTCIInds(ii,jj) = sum(distyh(asmattemp(:,jj)==ii,jj).*NumSurvsLTCINHbyyh(asmattemp(:,jj)==ii,jj) ) + ...
            sum(distyh(asmattemp(:,jj)==ii+ngw,jj).*NumSurvsLTCINHbyyh(asmattemp(:,jj)==ii+ngw,jj)).*( 0.25*ii- sum(distyh(asmattemp<=ii))-sum(distyh(asmattemp>ngw & asmattemp<ii+ngw )))/sum(distyh(asmattemp==ii+ngw));
         if (ii>1)
             fracLTCIInds(ii,jj) = fracLTCIInds(ii,jj) + ...
                 sum(distyh(asmattemp(:,jj)==ii+ngw-1,jj).*NumSurvsLTCINHbyyh(asmattemp(:,jj)==ii+ngw-1,jj)).*(1-( 0.25*(ii-1)- sum(distyh(asmattemp<=ii-1))-sum(distyh(asmattemp>ngw & asmattemp<ii+ngw-1 )))/sum(distyh(asmattemp==ii+ngw-1)));
         end        
    end
    end
    FracLTCSurvsEnterNHbyahqr= fracLTCIInds./fracInds;
    %fraction survivors with LTCI who enter NH by wealth quartile and frailty quintile. 
    FracLTCSurvsEnterNHbyahqr = FracLTCSurvsEnterNHbyahqr';      
    
    %Fraction survivors without LTCI who enter NH by wealth quartile and frailty quintile
    fracInds = zeros(ngw,ng);
    fracLTCIInds = zeros(ngw,ng);
    for jj=1:ng
    for ii=1:ngw
        fracInds(ii,jj) = sum(NumSurvsNoLTCIbyyh(asmattemp(:,jj)==ii,jj).*distyh(asmattemp(:,jj)==ii,jj)) + ...
            sum(NumSurvsNoLTCIbyyh(asmattemp(:,jj)==ii+ngw,jj).*distyh(asmattemp(:,jj)==ii+ngw,jj)).*( 0.25*ii- sum(distyh(asmattemp<=ii))...
            -sum(distyh(asmattemp>ngw & asmattemp<ii+ngw )))/sum(distyh(asmattemp==ii+ngw));  
         if (ii>1)
             fracInds(ii,jj) = fracInds(ii,jj) + ...
                 sum(distyh(asmattemp(:,jj)==ii+ngw-1,jj).*NumSurvsNoLTCIbyyh(asmattemp(:,jj)==ii+ngw-1,jj)).*(1-( 0.25*(ii-1)- sum(distyh(asmattemp<=ii-1))-sum(distyh(asmattemp>ngw & asmattemp<ii+ngw-1 )))/sum(distyh(asmattemp==ii+ngw-1)));
         end
         fracLTCIInds(ii,jj) = sum(distyh(asmattemp(:,jj)==ii,jj).*NumSurvsNoLTCINHbyyh(asmattemp(:,jj)==ii,jj) ) + ...
            sum(distyh(asmattemp(:,jj)==ii+ngw,jj).*NumSurvsNoLTCINHbyyh(asmattemp(:,jj)==ii+ngw,jj)).*( 0.25*ii- sum(distyh(asmattemp<=ii))-sum(distyh(asmattemp>ngw & asmattemp<ii+ngw )))/sum(distyh(asmattemp==ii+ngw));
         if (ii>1)
             fracLTCIInds(ii,jj) = fracLTCIInds(ii,jj) + ...
                 sum(distyh(asmattemp(:,jj)==ii+ngw-1,jj).*NumSurvsNoLTCINHbyyh(asmattemp(:,jj)==ii+ngw-1,jj)).*(1-( 0.25*(ii-1)- sum(distyh(asmattemp<=ii-1))-sum(distyh(asmattemp>ngw & asmattemp<ii+ngw-1 )))/sum(distyh(asmattemp==ii+ngw-1)));
         end        
    end
    end
    FracNonLTCSurvsEnterNHbyahqr= fracLTCIInds./fracInds;
    %fraction survivors with LTCI who enter NH by wealth quartile and frailty quintile. 
    FracNonLTCSurvsEnterNHbyahqr = FracNonLTCSurvsEnterNHbyahqr';     
    
    %Fraction all those with LTCI who enter NH by wealth quartile and frailty quintile
    fracInds = zeros(ngw,ng);
    fracLTCIInds = zeros(ngw,ng);
    for jj=1:ng
    for ii=1:ngw
        fracInds(ii,jj) = sum(NumIndsLTCIbyyh(asmattemp(:,jj)==ii,jj).*distyh(asmattemp(:,jj)==ii,jj)) + ...
            sum(NumIndsLTCIbyyh(asmattemp(:,jj)==ii+ngw,jj).*distyh(asmattemp(:,jj)==ii+ngw,jj)).*( 0.25*ii- sum(distyh(asmattemp<=ii))...
            -sum(distyh(asmattemp>ngw & asmattemp<ii+ngw )))/sum(distyh(asmattemp==ii+ngw));  
         if (ii>1)
             fracInds(ii,jj) = fracInds(ii,jj) + ...
                 sum(distyh(asmattemp(:,jj)==ii+ngw-1,jj).*NumIndsLTCIbyyh(asmattemp(:,jj)==ii+ngw-1,jj)).*(1-( 0.25*(ii-1)- sum(distyh(asmattemp<=ii-1))-sum(distyh(asmattemp>ngw & asmattemp<ii+ngw-1 )))/sum(distyh(asmattemp==ii+ngw-1)));
         end
         fracLTCIInds(ii,jj) = sum(distyh(asmattemp(:,jj)==ii,jj).*NumSurvsLTCINHbyyh(asmattemp(:,jj)==ii,jj) ) + ...
            sum(distyh(asmattemp(:,jj)==ii+ngw,jj).*NumSurvsLTCINHbyyh(asmattemp(:,jj)==ii+ngw,jj)).*( 0.25*ii- sum(distyh(asmattemp<=ii))-sum(distyh(asmattemp>ngw & asmattemp<ii+ngw )))/sum(distyh(asmattemp==ii+ngw));
         if (ii>1)
             fracLTCIInds(ii,jj) = fracLTCIInds(ii,jj) + ...
                 sum(distyh(asmattemp(:,jj)==ii+ngw-1,jj).*NumSurvsLTCINHbyyh(asmattemp(:,jj)==ii+ngw-1,jj)).*(1-( 0.25*(ii-1)- sum(distyh(asmattemp<=ii-1))-sum(distyh(asmattemp>ngw & asmattemp<ii+ngw-1 )))/sum(distyh(asmattemp==ii+ngw-1)));
         end        
    end
    end
    FracLTCEnterNHbyahqr= fracLTCIInds./fracInds;
    %fraction all those with LTCI who enter NH by wealth quartile and frailty quintile. 
    FracLTCEnterNHbyahqr = FracLTCEnterNHbyahqr';          
    
    %Fraction all those without LTCI who enter NH by wealth quartile and frailty quintile
    fracInds = zeros(ngw,ng);
    fracLTCIInds = zeros(ngw,ng);
    for jj=1:ng
    for ii=1:ngw
        fracInds(ii,jj) = sum(NumIndsNoLTCIbyyh(asmattemp(:,jj)==ii,jj).*distyh(asmattemp(:,jj)==ii,jj)) + ...
            sum(NumIndsNoLTCIbyyh(asmattemp(:,jj)==ii+ngw,jj).*distyh(asmattemp(:,jj)==ii+ngw,jj)).*( 0.25*ii- sum(distyh(asmattemp<=ii))...
            -sum(distyh(asmattemp>ngw & asmattemp<ii+ngw )))/sum(distyh(asmattemp==ii+ngw));  
         if (ii>1)
             fracInds(ii,jj) = fracInds(ii,jj) + ...
                 sum(distyh(asmattemp(:,jj)==ii+ngw-1,jj).*NumIndsNoLTCIbyyh(asmattemp(:,jj)==ii+ngw-1,jj)).*(1-( 0.25*(ii-1)- sum(distyh(asmattemp<=ii-1))-sum(distyh(asmattemp>ngw & asmattemp<ii+ngw-1 )))/sum(distyh(asmattemp==ii+ngw-1)));
         end
         fracLTCIInds(ii,jj) = sum(distyh(asmattemp(:,jj)==ii,jj).*NumSurvsNoLTCINHbyyh(asmattemp(:,jj)==ii,jj) ) + ...
            sum(distyh(asmattemp(:,jj)==ii+ngw,jj).*NumSurvsNoLTCINHbyyh(asmattemp(:,jj)==ii+ngw,jj)).*( 0.25*ii- sum(distyh(asmattemp<=ii))-sum(distyh(asmattemp>ngw & asmattemp<ii+ngw )))/sum(distyh(asmattemp==ii+ngw));
         if (ii>1)
             fracLTCIInds(ii,jj) = fracLTCIInds(ii,jj) + ...
                 sum(distyh(asmattemp(:,jj)==ii+ngw-1,jj).*NumSurvsNoLTCINHbyyh(asmattemp(:,jj)==ii+ngw-1,jj)).*(1-( 0.25*(ii-1)- sum(distyh(asmattemp<=ii-1))-sum(distyh(asmattemp>ngw & asmattemp<ii+ngw-1 )))/sum(distyh(asmattemp==ii+ngw-1)));
         end        
    end
    end
    FracNonLTCEnterNHbyahqr= fracLTCIInds./fracInds;
    %fraction all those without LTCI who enter NH by wealth quartile and frailty quintile. 
    FracNonLTCEnterNHbyahqr = FracNonLTCEnterNHbyahqr';         
    
    asmeanvect(soltype) = as_mean;
    postasmeanvect(soltype) = postas_mean;
    postasNHmeanvect(soltype) = postasNH_mean;          
    
    %profits_byyhq_bad = get_dist_stats_jointx_x(profitsmat, ymat, distyh, phi_cutoffs, y_cutoffs, disth, ng);


%%%%%to get output back need to uncomment this%%%%%
    
%% save output
     savetofile = 1;
     formatOut = 'yyyymmdd_HHMMSS';
     dt = datestr(now,formatOut);
     s = strcat( dt,'_v',num2str(soltype),'.mat' );
     fs = strcat( dt,'_v',num2str(soltype),'.xls' );
     save(s);   
     names{soltype} = s;
    
%% output stats
%    output;
    outputfile;
    
%% make plots
%    sp=(jj-1)*100+(soltype-1)*10;
%    make_plots;
    
end

 
 if (Utilityvect(2) > 0)
    fprintf(1,'CV            \t %g \t %g\n', [(Utilityvect(1)./Utilityvect(2)).^(1/(1-sigma))-1; (Utilityvect(2)./Utilityvect(1)).^(1/(1-sigma))-1]);  
 end
disp('-----------------------------');
 

if Ns > 2
    
U0matAll = cell(1,Ns); 
profitsmatAll = cell(1,Ns); 
VAR1 = 'U0mat'; 
VAR2 = 'profitsmat';
for soltype=1:Ns
    %s = strcat( 'output_case',num2str(soltype),'.mat' );
    s = names{soltype};
    U0mat_temp = load(s,VAR1);  % Function output form of LOAD
    U0matAll{soltype} = U0mat_temp.(VAR1);
    profitsmat_temp = load(s,VAR2);
    profitsmatAll{soltype} = profitsmat_temp.(VAR2);
end


sp =(jj-1)*100+ soltype*10+1;
figure(sp);
p=plot(ymat,U0matAll{1}-U0matAll{2},'*-'); 
set(p,'LineWidth',3 );
grid
legend('h=1(bad)','h=2','h=3','h=4','h=5(good)');
legend('boxoff')
title('Utility w/ PI - Utility w/o PI')
xlabel('income')

figure(sp+1);
p=plot(ymat,profitsmatAll{1}-profitsmatAll{2},'*-'); 
set(p,'LineWidth',3 );
grid
legend('h=1(bad)','h=2','h=3','h=4','h=5(good)');
legend('boxoff')
title('Profits w/ PI - Profits w/o PI')
xlabel('income')

end
