function dist = get_discrete_dist(grid1, grid2, mean1, stdev1, a2, b2, cov12)
        
        n1 = length(grid1);
        n2 = length(grid2);
        dist = zeros(n1,n2);
               
        w1vect = (grid1(2:n1) - grid1(1:n1-1))/2;
        w2vect = (grid2(2:n2) - grid2(1:n2-1))/2;
        
        lnpts1 = zeros(1,n1);
        rhpts1 = zeros(1,n1);
        lhpts2 = zeros(1,n2);
        rhpts2 = zeros(1,n2);
        
        lhpts1(2:n1) = grid1(2:n1) - w1vect;
        rhpts1(1:n1-1) = grid1(1:n1-1) + w1vect;
        lhpts2(2:n2) = grid2(2:n2) - w2vect;
        rhpts2(1:n2-1) = grid2(1:n2-1) + w2vect;        
        
        cdf_ll = get_joint_dist(lhpts1, lhpts2, mean1, stdev1, a2, b2, cov12,2);
        cdf_lr = get_joint_dist(lhpts1, rhpts2, mean1, stdev1, a2, b2, cov12,2);
        cdf_rl = get_joint_dist(rhpts1, lhpts2, mean1, stdev1, a2, b2, cov12,2);
        cdf_rr = get_joint_dist(rhpts1, rhpts2, mean1, stdev1, a2, b2, cov12,2);
        
        lhmargs = get_joint_dist(lhpts1, lhpts2, mean1, stdev1, a2, b2, cov12,3);
        rhmargs = get_joint_dist(rhpts1, rhpts2, mean1, stdev1, a2, b2, cov12,3);        
        
        dist = cdf_ll - cdf_lr - cdf_rl + cdf_rr; %area 1
        
        dist(:,1) = cdf_rr(:,1) - cdf_lr(:,1); %area 3        
        dist(1,:) = cdf_rr(1,:) - cdf_rl(1,:); %area 2
        
        dist(:,n2) = rhmargs(1:n1,1) - lhmargs(1:n1,1) - cdf_rl(:,n2) + cdf_ll(:,n2); %area 5
        dist(n1,:) = rhmargs(1:n2,2)' - lhmargs(1:n2,2)' - cdf_lr(n1,:) + cdf_ll(n1,:); %area 4

        dist(1,1) = cdf_rr(1,1); %area 6
        dist(1,n2) = rhmargs(1,1) - cdf_rl(1,n2); %area 7
        dist(n1,n2) = 1 - lhmargs(n1,1) - lhmargs(n2,2) + cdf_ll(n1,n2); %area 8
        dist(n1,1) =  rhmargs(1,2) - cdf_lr(n1,1); %area 9

        
    end 