function [grp_means,  grp_shares, vals_cutoffs,  ind_cutoffs] = get_dist_stats(asvect, distyhvect, cutoffs)    

ng = length(cutoffs);
cumdistyhvect = cumsum(distyhvect);
ind_cutoffs = zeros(1,ng);
grp_shares = zeros(1,ng);

for i = 1:ng-1
    ind_cutoffs(i) = find(cutoffs(i) <= cumdistyhvect,1,'first');
end
ind_cutoffs(ng) = length(cumdistyhvect);
vals_cutoffs = asvect(ind_cutoffs); %these will be wealth at each quintile

wgts = zeros(1,ind_cutoffs(1));
if (ind_cutoffs(1) > 1)
    wgts(1:ind_cutoffs(1)-1) = distyhvect(1:ind_cutoffs(1)-1);
    wgts(ind_cutoffs(1)) = cutoffs(1) - cumdistyhvect(ind_cutoffs(1)-1);
else 
    wgts = cutoffs(1);
end
grp_shares(1) = sum( asvect(1:ind_cutoffs(1)).*wgts);
clear wgts;

for i=2:ng
    nwgts = ind_cutoffs(i)-ind_cutoffs(i-1)+1;
    wgts = zeros(1,nwgts);
    if (nwgts > 1)
        wgts(2:nwgts-1) = distyhvect(ind_cutoffs(i-1)+1:ind_cutoffs(i)-1);
        wgts(nwgts) = cutoffs(i) - cumdistyhvect(ind_cutoffs(i)-1);
        wgts(1) = cumdistyhvect(ind_cutoffs(i-1))-(i-1)/ng;
    else 
        wgts =  cutoffs(i)-cutoffs(i-1);
    end
    grp_shares(i) = sum( asvect(ind_cutoffs(i-1):ind_cutoffs(i)).*wgts);
end

grp_means = grp_shares.*ng;  %these will be the mean wealth values for each quintile
totalwealth = sum( asvect.*distyhvect );
grp_shares = grp_shares./totalwealth; %share of wealth held by each quintile
