function [grp_means,  grp_shares, vals_cutoffs,  ind_cutoffs] = get_dist_stats_jointx(xmat, distyh, indh_cutoffs, disth, ng)    

ind_cutoffs = zeros(ng,ng);
grp_shares = zeros(ng,ng);
grp_means = zeros(ng,ng);
vals_cutoffs = zeros(ng,ng);

cumdisth = cumsum(disth);
xmat_t = xmat(:,1:indh_cutoffs(1));
xvect = reshape(xmat_t,1,size(xmat_t,1)*size(xmat_t,2));
dist_t = distyh(:,1:indh_cutoffs(1));
    
if (indh_cutoffs(1) > 1)
    dist_t(:,indh_cutoffs(1)) = dist_t(:,indh_cutoffs(1)) .* ((1/ng-cumdisth(indh_cutoffs(1)-1))/disth(indh_cutoffs(1)));
else
    dist_t(:,indh_cutoffs(1)) = dist_t(:,indh_cutoffs(1))/ng/disth(indh_cutoffs(1));
end
dist_t = dist_t*ng;
dist_tvect = reshape(dist_t,1,size(xmat_t,1)*size(xmat_t,2));

if abs(sum(dist_tvect) - 1) > 1e-8
    keyboard
end

[xvect, ind_sort] = sort(xvect);    
dist_tvect = dist_tvect(ind_sort);      
    
[grp_means(1,:),  grp_shares(1,:), vals_cutoffs(1,:),  ind_cutoffs(1,:)] = get_dist_stats(xvect, dist_tvect, linspace(1/ng,1,ng));    
    
for i=2:ng
    xmat_t = xmat(:,indh_cutoffs(i-1):indh_cutoffs(i));
    xvect = reshape(xmat_t,1,size(xmat_t,1)*size(xmat_t,2));
    dist_t = distyh(:,indh_cutoffs(i-1):indh_cutoffs(i));
    nwgts = indh_cutoffs(i)-indh_cutoffs(i-1)+1;
    if (nwgts > 1)
        dist_t(:,1) = dist_t(:,1) .* ((cumdisth(indh_cutoffs(i-1)) - (i-1)/ng)/disth(indh_cutoffs(i-1)));
        dist_t(:,end) = dist_t(:,end) .* ((i/ng-cumdisth(indh_cutoffs(i)-1))/disth(indh_cutoffs(i)));
    else 
        dist_t(:,end) = dist_t(:,end)/ng/disth(indh_cutoffs(i));
    end
    dist_t = dist_t*ng;
    dist_tvect = reshape(dist_t,1,size(xmat_t,1)*size(xmat_t,2));

    [xvect, ind_sort] = sort(xvect);    
    dist_tvect = dist_tvect(ind_sort);      

    [grp_means(i,:),  grp_shares(i,:), vals_cutoffs(i,:),  ind_cutoffs(i,:)] = get_dist_stats(xvect, dist_tvect, linspace(1/ng,1,ng));    
    
end

    
