function [grp_means,  grp_shares] = get_dist_stats_x(xvect, distyhvect, ind_cutoffs, ng)    

grp_shares = zeros(1,ng);

cumdistyhvect = cumsum(distyhvect);
wgts = zeros(1,ind_cutoffs(1));
if (ind_cutoffs(1) > 1)
    wgts(1:ind_cutoffs(1)-1) = distyhvect(1:ind_cutoffs(1)-1);
    wgts(ind_cutoffs(1)) = 1/ng - cumdistyhvect(ind_cutoffs(1)-1);
else 
    wgts = 1/ng;
end
grp_shares(1) = sum( xvect(1:ind_cutoffs(1)).*wgts);

clear wgts;

for i=2:ng
    nwgts = ind_cutoffs(i)-ind_cutoffs(i-1)+1;
    wgts = zeros(1,nwgts);
    if (nwgts > 1)
        wgts(2:nwgts-1) = distyhvect(ind_cutoffs(i-1)+1:ind_cutoffs(i)-1);
        wgts(nwgts) = i/ng - cumdistyhvect(ind_cutoffs(i)-1);
        wgts(1) = cumdistyhvect(ind_cutoffs(i-1))-(i-1)/ng;
    else 
        wgts = 1/ng;
    end
    grp_shares(i) = sum( xvect(ind_cutoffs(i-1):ind_cutoffs(i)).*wgts);
    
end

grp_means = grp_shares.*ng;  %these will be the mean wealth values for each quintile
totalwealth = sum( xvect.*distyhvect );
grp_shares = grp_shares./totalwealth; %share of wealth held by each quintile



