    
function distxy = get_joint_dist(x,y,mean_logx,stdev_logx,a_y,b_y,cov_xy,flag)

S = [1 cov_xy; cov_xy 1]; %var-cov matrix
       
Fx = cdf('logn', x,mean_logx,stdev_logx); %U %use whatever want marginal to be here
Fy = cdf('beta', y,a_y,b_y);

Zx = icdf('norm',Fx,0,1); %Z %use standard normal here
Zy = icdf('norm',Fy,0,1);
    
n = length(x);
m= length(y);

switch flag
    
    case 1

        distxy = zeros(n,m);
        for i=1:m   
            distxy(:,i) = mvnpdf([Zx' Zy(i)*ones(n,1)],[0 0],S);        
        end

    case 2
        distxy = zeros(n,m);
        for i=1:m   
            distxy(:,i) = mvncdf([Zx' Zy(i)*ones(n,1)],[0 0],S);        
        end 

    case 3
        distxy = zeros(max(n,m),2);
        distxy(1:n,1) = Fx;  
        distxy(1:m,2) = Fy; 
      
end


return;

end
    
