function [U0_out, as_out, maxprofitsvect, maxtlvect, maxxlvect, maxthvect, maxxhvect, ...
    optcase, poolsolvect, maxcy, maxcll, maxchl, maxcl, maxch, maxU1, Oncfloors] = ...
    govtbudget_objective(phi, wy, wo, ls, nk, soltype, sigma, r, l, chat, chat2, tau, thetal_vect, thetah_vect, survprobl, survprobh, ...
    beta, alpha_vect, cmin, cmin2, cmin3, lambda, k, distkappa, kappavect, udeath, udeathprime)      

    %TolFunFzeros = 1.e-4;
    TolFunFzeros = 1.e-12;
    TolFunFzeros2 = 1.e-3;
    MaxFunEvalsfzeros = 300;

    if (cmin2 == 0)
        amin = max(0,(kappavect(nk).*wy -wo*(1-tau) -ls)/(1+r-tau*r)*1.01);
   %     amin = 0.07*wy;
        
        %fprintf('amin=%g',amin);
    else
        amin = 0;
    end
    %amin = max(0,(l + kappavect(nk).*wy -wo*(1-tau) -ls));
    %amin = min(0.9*max(0,(l + kappavect(nk).*wy -wo*(1-tau) -ls)),wy*(1-tau)*beta/(1+beta));
    amax = min(0.99*wy*(1-tau),max(chat*1.1,wy*(1-tau)*beta/(1+beta))+l*1.1+kappavect(nk)*wy);
    
    %amax = 0.9*wy*(1-tau);
    %(l - wo*(1-tau) - ls +kappavect(nk)*wy)/(1+r-tau*r)


    %Find optimal savings, utility and contracts 
    %ag = amin;
    if ~isreal(amin)
        fprintf('govetbudget: amin not real\n');
        %keyboard
    end
    if ~isreal(amax)
        fprintf('govetbudget: amax not real\n');
        %keyboard
    end       
    %U0_out = U0(ag);
%%%%%%%%%
       cnkspvect = zeros(1,nk);
       chkspvect2 = zeros(1,nk);
    if (cmin > chat)       
        for ki=1:nk
            if soltype == 1
                if ki>1 && isnan(cnkspvect(ki-1))
                    cnkspvect(ki+1) = nan;                    
                else
                    FOCp_1=@(x)  FOCp(x, log(cmin-chat), ki, alpha_vect, sigma, r, chat, chat2, wo, wy, tau, phi, thetal_vect, thetah_vect, survprobl, survprobh, ...
                    0, cmin, cmin2, lambda, ls, nk, kappavect, distkappa, udeath, udeathprime)  ;                         
                    cnkspvect(ki) = fzero(FOCp_1,log(cmin), optimset('TolFun',TolFunFzeros2,'display','off','MaxFunEvals',MaxFunEvalsfzeros));               
                end
            else
                    FOCl_1=@(x)  focl(x, log(cmin-chat), ki, alpha_vect, sigma, chat,  wy, thetal_vect, survprobl, cmin, cmin2, lambda, nk, kappavect, distkappa)  ;                         
                    cnkspvect(ki) = fzero(FOCl_1,log(cmin), optimset('TolFun',TolFunFzeros2,'display','off','MaxFunEvals',MaxFunEvalsfzeros)); 
            end
            FOCh_1=@(x)  foch(x, log(cmin-chat), ki, alpha_vect, sigma, r, chat, wo, wy, tau, thetah_vect, survprobh, ...
                0, cmin, cmin2, lambda, ls, nk, kappavect, distkappa, udeathprime)  ;
            chkspvect2(ki) = fzero(FOCh_1,log(cmin), optimset('TolFun',TolFunFzeros2,'display','off','MaxFunEvals',MaxFunEvalsfzeros));               
        end
        
    end
    
%%%%%%%%%%%%%%%%%%%%%%
    %use this to see the convexity in the value function when MTSI is
    %present
           
%            na=200;
%            %agrid = linspace(amin,amax,na);
%            agrid = linspace(0.449731065634738,amax,na);
%            U0grid = zeros(1,na);
%            xhsmat3 = zeros(1,na);
%            xlsmat3 = zeros(1,na);
%            thsmat3 = zeros(1,na);
%            tlsmat3 = zeros(1,na);
%            profits3 = zeros(1,na);
%            transhmat3 = zeros(na,nk);
%            translmat3 = zeros(na,nk);
%            MTSIh3 = zeros(na,nk);
%            MTSIl3 = zeros(na,nk);
%            for ai=1:na
%               % U0grid(ai) = U0(agrid(ai))*-1;
%               %keyboard
%                [U0grid(ai), maxprofitsvect, maxtlvect, maxxlvect, maxthvect, maxxhvect, optcase, poolsolvect, maxcy, maxcll, maxchl, maxcl, maxch, maxU1] =...
%                 U0_2(agrid(ai), phi, wy, wo, ls, nk, soltype, sigma, r, l, chat, chat2, tau, thetal_vect, thetah_vect, ...
%         survprobl, survprobh, beta, alpha_vect, cmin, cmin2, lambda, k, distkappa, kappavect, udeath, udeathprime,cnkspvect,chkspvect2)  ;
%                xhsmat3(ai) = maxxhvect(optcase);
%                xlsmat3(ai) = maxxlvect(optcase);
%                thsmat3(ai) = maxthvect(optcase);
%                tlsmat3(ai) = maxtlvect(optcase);    
%                profits3(ai) = maxprofitsvect(optcase);
%                transhmat3(ai,:) = max(0,cmin - ((1+r)*agrid(ai) - l + maxxhvect(optcase) - maxthvect(optcase) + wo*(1-tau) + ls - tau*r*agrid(ai) -kappavect.*wy ));
%                translmat3(ai,:) = max(0,cmin - ((1+r)*agrid(ai) - l + maxxlvect(optcase)- maxtlvect(optcase) + wo*(1-tau) + ls - tau*r*agrid(ai) -kappavect.*wy));       
% 
%            end
%            MTSIh3(transhmat3 > 0) = 1;
%            MTSIl3(transhmat3 > 0) = 1; 
%            sum(MTSIh3,2)'
%            figure(10);
%            plot(agrid,-U0grid,'*');
%            figure(11);
%            plot(agrid,xhsmat3,'*'); 
%            figure(13);
%            plot(agrid,xlsmat3,'*');   
%            figure(14);
%            plot(agrid,xhsmat3-xlsmat3,'*');              
%            figure(12);
%            plot(agrid,sum(MTSIh3,2)','*');              
%            keyboard
           
    
    
%%%%%%%%%%%%%%%%%%    
    
    U0_tmp = @(x) U0(x, phi, wy, wo, ls, nk, soltype, sigma, r, l, chat, chat2, tau, thetal_vect, ...
        thetah_vect, survprobl, survprobh, beta, alpha_vect, cmin, cmin2, lambda, k, distkappa, kappavect, udeath, udeathprime,cnkspvect,chkspvect2)  ;
    as_out = fminbnd(U0_tmp, amin,amax,...
  optimset('MaxFunEvals',MaxFunEvalsfzeros,'TolX',TolFunFzeros,'display','off'));              
 %%%%%%%%%%HERE%%%%%%%%%%%
 %load PrevRuns5.mat; 
 %as_out = asmatSaved(64,1);
%as_out = chat2;
%if (as_out > 0)
    [U0_out, maxprofitsvect, maxtlvect, maxxlvect, maxthvect, maxxhvect, optcase, poolsolvect, maxcy, maxcll, maxchl, maxcl, maxch, maxU1] =...
            U0_2(as_out, phi, wy, wo, ls, nk, soltype, sigma, r, l, chat, chat2, tau, thetal_vect, thetah_vect, ...
            survprobl, survprobh, beta, alpha_vect, cmin, cmin2, lambda, k, distkappa, kappavect, udeath, udeathprime,cnkspvect,chkspvect2)  ;

        if U0_out == 10000
           fprintf('govetbudget: consumption also negative\n');
          % keyboard
        end

        U0_out = -U0_out;  
%       keyboard 
    %%%%%%%%%%%%%
%else
%    U0_out = -10000;
%end
maxcy0 = wy*(1-tau);
cl0_vect = max(- l +(1-tau)*wo +ls-kappavect.*wy, cmin);
c0_vect = max(cmin3,(1-tau)*wo +ls - kappavect.*wy);
U2h = sum( alpha_vect.*( survprobh.*(thetah_vect .* (cl0_vect-chat).^(1-sigma)./(1-sigma) + (1-thetah_vect) .* c0_vect.^(1-sigma)./(1-sigma)) ...
     +(1-survprobh).*udeath(c0_vect)  ).*distkappa ); 
U2l = sum( alpha_vect.*( survprobl.*(thetal_vect .* (cl0_vect-chat).^(1-sigma)./(1-sigma) + (1-thetal_vect) .* c0_vect.^(1-sigma)./(1-sigma)) ...
     +(1-survprobl).*udeath(c0_vect)  ).*distkappa ); 
maxU10 = beta* (phi*U2l + (1-phi)*U2h);
U0alt = (maxcy0).^(1-sigma)./(1-sigma) + maxU10 + beta.*sum((1-0).*kappavect.^(1-sigma).*distkappa).*wy.^(1-sigma)./(1-sigma);

Oncfloors = 0;
if (U0alt > U0_out)
   % fprintf(1,'switching to U0alt\n');
    U0_out = U0alt;
    as_out = 0;
    maxprofitsvect = 0;
    maxtlvect = 0;
    maxthvect = 0;
    maxxhvect = 0;
    maxxlvect = 0;
    optcase = 1;
    poolsolvect = 1;
    maxcy = maxcy0;
    maxcll = cl0_vect(1);
    maxchl = cl0_vect(1);
    maxcl = c0_vect(1);
    maxch = c0_vect(1); 
    maxU1 = maxU10;
    Oncfloors = 1;
end
%%%%%%%%%%%%%%
  %  keyboard