%New baseline May 2018

clear all;
close all;
files={'20180502_115539_v1.mat','20180502_154049_v1.mat','20180502_161729_v2.mat'}; %baseline, No Medicaid and Full Information economies

Profitsbyahqvect = zeros(5,5,2);
profitsbyyhqvect = zeros(5,5,2);

profitssharebyyhqvect = zeros(5,5,2);

for fi=1:length(files)
   
    load(files{fi});
    
    %%%%
    wealthmat = (1+r)*asmat + lsmat*(1-tau) - tau*r*asmat;
    %calculate wealth distribution moments pre-kappa shock and pre-death event
    asvect = reshape(wealthmat,1,ny*nh);
    distyhvect = reshape(distyh,1,ny*nh);
    [asvect, ind_sort] = sort(asvect);
    distyhvect = distyhvect(ind_sort);
    ng = 5;
    as_mean = sum(asvect.*distyhvect);
    [as_qmeans,  as_shares, as_qvalues, as_cutoffs] = get_dist_stats(asvect, distyhvect, linspace(1/ng,1,ng));
    [as_pmeansBAD,  as_psharesBAD, as_pvalues, as_pcutoffs] = get_dist_stats(asvect, distyhvect, [0.5 0.9 0.95 0.99]);
    as_gini=get_gini(distyhvect,asvect);      
   
    asmattemp =zeros(ny,nh);
    for ii=ng:-1:1
        asmattemp( (wealthmat < as_qvalues(ii)) ) = ii;
        asmattemp(wealthmat==as_qvalues(ii)) = ii+5;
    end
    fracInds = zeros(ng,ng);
    fracLTCIInds = zeros(ng,ng);
    for jj=1:ng
    for ii=1:ng
        fracInds(ii,jj) = sum(distyh(asmattemp(:,jj)==ii,jj)) + ...
            sum(distyh(asmattemp(:,jj)==ii+5,jj)).*( 0.2*ii- sum(distyh(asmattemp<=ii))-sum(distyh(asmattemp>5 & asmattemp<ii+5 )))/sum(distyh(asmattemp==ii+5));
         if (ii>1)
             fracInds(ii,jj) = fracInds(ii,jj) + ...
                 sum(distyh(asmattemp(:,jj)==ii+4,jj)).*(1-( 0.2*(ii-1)- sum(distyh(asmattemp<=ii-1))-sum(distyh(asmattemp>5 & asmattemp<ii+4 )))/sum(distyh(asmattemp==ii+4)));
         end
         fracLTCIInds(ii,jj) = sum(distyh(asmattemp(:,jj)==ii,jj).*FracLTCIbyyh(asmattemp(:,jj)==ii,jj) ) + ...
            sum(distyh(asmattemp(:,jj)==ii+5,jj).*FracLTCIbyyh(asmattemp(:,jj)==ii+5,jj)).*( 0.2*ii- sum(distyh(asmattemp<=ii))-sum(distyh(asmattemp>5 & asmattemp<ii+5 )))/sum(distyh(asmattemp==ii+5));
         if (ii>1)
             fracLTCIInds(ii,jj) = fracLTCIInds(ii,jj) + ...
                 sum(distyh(asmattemp(:,jj)==ii+4,jj).*FracLTCIbyyh(asmattemp(:,jj)==ii+4,jj)).*(1-( 0.2*(ii-1)- sum(distyh(asmattemp<=ii-1))-sum(distyh(asmattemp>5 & asmattemp<ii+4 )))/sum(distyh(asmattemp==ii+4)));
         end        
    end
    end
    FracLTCIbyahq= fracLTCIInds./fracInds;
    FracLTCIbyahq = FracLTCIbyahq';
    
    
    
    
    fracInds = zeros(ng,ng);
    fracLTCIInds = zeros(ng,ng);
    for jj=1:ng
    for ii=1:ng
        fracInds(ii,jj) = sum(distyh(asmattemp(:,jj)==ii,jj)) + ...
            sum(distyh(asmattemp(:,jj)==ii+5,jj)).*( 0.2*ii- sum(distyh(asmattemp<=ii))-sum(distyh(asmattemp>5 & asmattemp<ii+5 )))/sum(distyh(asmattemp==ii+5));
         if (ii>1)
             fracInds(ii,jj) = fracInds(ii,jj) + ...
                 sum(distyh(asmattemp(:,jj)==ii+4,jj)).*(1-( 0.2*(ii-1)- sum(distyh(asmattemp<=ii-1))-sum(distyh(asmattemp>5 & asmattemp<ii+4 )))/sum(distyh(asmattemp==ii+4)));
         end
         profitst(ii,jj) = sum(distyh(asmattemp(:,jj)==ii,jj).*profitsmat(asmattemp(:,jj)==ii,jj) ) + ...
            sum(distyh(asmattemp(:,jj)==ii+5,jj).*profitsmat(asmattemp(:,jj)==ii+5,jj)).*( 0.2*ii- sum(distyh(asmattemp<=ii))-sum(distyh(asmattemp>5 & asmattemp<ii+5 )))/sum(distyh(asmattemp==ii+5));
         if (ii>1)
             profitst(ii,jj) = profitst(ii,jj) + ...
                 sum(distyh(asmattemp(:,jj)==ii+4,jj).*profitsmat(asmattemp(:,jj)==ii+4,jj)).*(1-( 0.2*(ii-1)- sum(distyh(asmattemp<=ii-1))-sum(distyh(asmattemp>5 & asmattemp<ii+4 )))/sum(distyh(asmattemp==ii+4)));
         end        
    end
    end
    Profitsbyahq= profitst./fracInds;
    Profitsbyahq = Profitsbyahq';    
    %clear asvect;
    Profitsbyahqvect(:,:,fi) = Profitsbyahq;
    
    %%%%%%%%
    ymattemp =zeros(ny,nh);
    for ii=ng:-1:1
        ymattemp( (ymat < y_qvalues(ii)) ) = ii;
        ymattemp(ymat==y_qvalues(ii)) = ii+5;
    end    
    fracInds = zeros(ng,ng);
    fracLTCIInds = zeros(ng,ng);
    for jj=1:ng
    for ii=1:ng
        fracInds(ii,jj) = sum(distyh(ymattemp(:,jj)==ii,jj)) + ...
            sum(distyh(ymattemp(:,jj)==ii+5,jj)).*( 0.2*ii- sum(distyh(ymattemp<=ii))-sum(distyh(ymattemp>5 & ymattemp<ii+5 )))/sum(distyh(ymattemp==ii+5));
         if (ii>1)
             fracInds(ii,jj) = fracInds(ii,jj) + ...
                 sum(distyh(ymattemp(:,jj)==ii+4,jj)).*(1-( 0.2*(ii-1)- sum(distyh(ymattemp<=ii-1))-sum(distyh(ymattemp>5 & ymattemp<ii+4 )))/sum(distyh(ymattemp==ii+4)));
         end
         profitst(ii,jj) = sum(distyh(ymattemp(:,jj)==ii,jj).*profitsmat(ymattemp(:,jj)==ii,jj) ) + ...
            sum(distyh(ymattemp(:,jj)==ii+5,jj).*profitsmat(ymattemp(:,jj)==ii+5,jj)).*( 0.2*ii- sum(distyh(ymattemp<=ii))-sum(distyh(ymattemp>5 & ymattemp<ii+5 )))/sum(distyh(ymattemp==ii+5));
         if (ii>1)
             profitst(ii,jj) = profitst(ii,jj) + ...
                 sum(distyh(ymattemp(:,jj)==ii+4,jj).*profitsmat(ymattemp(:,jj)==ii+4,jj)).*(1-( 0.2*(ii-1)- sum(distyh(ymattemp<=ii-1))-sum(distyh(ymattemp>5 & ymattemp<ii+4 )))/sum(distyh(ymattemp==ii+4)));
         end        
    end
    end
    Profitsbyyhq= profitst./fracInds;
    Profitsbyyhq = Profitsbyyhq';    
    clear asvect;
    profitsbyyhqvect(:,:,fi) = Profitsbyyhq;
    Profitssharebyyhq = profitst./sum(sum(profitst));
    Profitssharebyyhq = Profitssharebyyhq';
    profitssharebyyhqvect(:,:,fi) = Profitssharebyyhq;
    %%%%%
    
    
    %profits_byyhq = get_dist_stats_jointx_x(profitsmat, ymat, distyh, phi_cutoffs, y_cutoffs, disth, ng);
    %profitsbyyhqvect(:,:,fi) = profits_byyhq;
    %%%%%%%
    
    sp=(fi-1)*10;    
    %make_plots;
    fprintf(1,'\n-------start file %g---------\n',fi);
    savetofile = 0;
    %outputfile;
    fprintf(1,'\n-------end file %g---------\n',fi);
    
    %rename all variables in file
    
    x = load(files{fi});
    names = fieldnames(x);
    
    for iname = 1:length(names)
      x.([names{iname},'_',num2str(fi)]) = x.(names{iname});
      x = rmfield(x, names{iname});
      
    end
    
    files2 = strcat('temp',num2str(fi),'_',files{fi});
    save(files2, '-struct', 'x');
    load(files2);
        
    
end

%% Make graphs

fSize =20;
fName = 'Helvetica';

Cmap =[0    0.4470    0.7410;0.8500    0.3250    0.0980;0.9290    0.6940    0.1250;0.4940    0.1840    0.5560;0.4660    0.6740    0.1880];
%Cmap = [0 165 255;255 144 0;155 155 155;255 212 0;0 100 255]/255;
C1 = Cmap(1,:);
C2 = Cmap(2,:);
C3 = Cmap(3,:);
C4 = Cmap(4,:);
C5 = Cmap(5,:);

mrksize = 3;
linewdt = 2;
percentchange = 100*(profitsmat_1-profitsmat_2)./profitsmat_2;
FrailtyTick = 1:1:5;

%% figure Baseline
profits_byyhq_1 = profitsbyyhqvect(:,:,1);
profits_byyhq_2 = profitsbyyhqvect(:,:,2);
Totalprofits_1 = sum(sum(profitsmat_1.*distyh));
Totalprofits_2 = sum(sum(profitsmat_2.*distyh));

profitshares_byyhq_1 = profitssharebyyhqvect(:,:,1);
profitshares_byyhq_2 = profitssharebyyhqvect(:,:,2);

figure
axes('FontSize',fSize,'FontName',fName,...
     'XTick',FrailtyTick,...
     'XGrid','off','YGrid','off');
box off
hold on;

for i=1:nh
    p(i)=plot(profits_byyhq_1(:,i)'.*100);                 
end
set(p,'LineWidth',linewdt );

set(p(1),'Color',C1,'Marker','diamond','MarkerSize',8,'MarkerFaceColor',C1)
set(p(2),'Color',C2,'Marker','o','MarkerSize',8,'MarkerFaceColor',C2)
set(p(3),'Color',C3,'Marker','square','MarkerSize',8,'MarkerFaceColor',C3)
set(p(4),'Color',C4,'Marker','^','MarkerSize',8,'MarkerFaceColor',C4)
set(p(5),'Color',C5,'Marker','x','MarkerSize',10,'MarkerFaceColor',C5)

xlabel('Frailty quintile')       
ylabel('Profits')

legend(p,{'PE quintile 1','PE quintile 2','PE quintile 3','PE quintile 4','PE quintile 5'},'Position',[0.38,0.06, 1, 1],'units','normalized');
legend boxoff

set(gcf,'PaperPositionMode','auto');
set(gcf,'PaperUnits','inches')
set(gcf,'PaperSize',[8.1,6])
set(gcf,'PaperPosition',[0.0,0.0,8,6])
set(gca,'LooseInset',get(gca,'TightInset'))
print(gcf,'-dpdf','ProfitsBaseline.pdf')

% ylim([0,0.0004]);    


%% figure profits No Medicaid
figure
axes('FontSize',fSize,'FontName',fName,...
     'XTick',FrailtyTick,...
     'XGrid','off','YGrid','off');
box off
hold on;

for i=1:nh
    p(i)=plot(profits_byyhq_2(:,i)'.*100);                 
end

set(p,'LineWidth',linewdt );

set(p(1),'Color',C1,'Marker','diamond','MarkerSize',8,'MarkerFaceColor',C1)
set(p(2),'Color',C2,'Marker','o','MarkerSize',8,'MarkerFaceColor',C2)
set(p(3),'Color',C3,'Marker','square','MarkerSize',8,'MarkerFaceColor',C3)
set(p(4),'Color',C4,'Marker','^','MarkerSize',8,'MarkerFaceColor',C4)
set(p(5),'Color',C5,'Marker','x','MarkerSize',10,'MarkerFaceColor',C5)

xlabel('Frailty quintile')       
ylabel('Profits')

legend(p,{'PE quintile 1','PE quintile 2','PE quintile 3','PE quintile 4','PE quintile 5'},'Position',[0.38,0.06, 1, 1],'units','normalized');
legend boxoff

set(gcf,'PaperPositionMode','auto');
set(gcf,'PaperUnits','inches')
set(gcf,'PaperSize',[8.1,6])
set(gcf,'PaperPosition',[0.0,0.0,8,6])
set(gca,'LooseInset',get(gca,'TightInset'))
print(gcf,'-dpdf','ProfitsNoMedicaid.pdf')

%% figure profits shares baseline
figure
axes('FontSize',fSize,'FontName',fName,...
     'XTick',FrailtyTick,...
     'XGrid','off','YGrid','off');
box off
hold on;

for i=1:nh
    p(i)=plot(profitshares_byyhq_1(:,i)'.*100);                 
end

set(p,'LineWidth',linewdt );

set(p(1),'Color',C1,'Marker','diamond','MarkerSize',8,'MarkerFaceColor',C1)
set(p(2),'Color',C2,'Marker','o','MarkerSize',8,'MarkerFaceColor',C2)
set(p(3),'Color',C3,'Marker','square','MarkerSize',8,'MarkerFaceColor',C3)
set(p(4),'Color',C4,'Marker','^','MarkerSize',8,'MarkerFaceColor',C4)
set(p(5),'Color',C5,'Marker','x','MarkerSize',10,'MarkerFaceColor',C5)  


xlabel('Frailty quintile')       
ylabel('Share of total profits (%)')

%legend(p,{'PE quintile 1','PE quintile 2','PE quintile 3','PE quintile 4','PE quintile 5'},'Position',[0.38,0.06, 1, 1],'units','normalized');
legend(p,{'PE quintile 1','PE quintile 2','PE quintile 3','PE quintile 4','PE quintile 5'},'location','NorthEast','orientation','vertical');

legend boxoff

set(gcf,'PaperPositionMode','auto');
set(gcf,'PaperUnits','inches')
set(gcf,'PaperSize',[8.1,6])
set(gcf,'PaperPosition',[0.0,0.0,8,6])
set(gca,'LooseInset',get(gca,'TightInset'))
print(gcf,'-dpdf','ProfitsSharesBaseline.pdf')
%%

%% figure profits shares No Medicaid
figure
axes('FontSize',fSize,'FontName',fName,...
     'XTick',FrailtyTick,...
     'XGrid','off','YGrid','off');
box off
hold on;

for i=1:nh
    p(i)=plot(profitshares_byyhq_2(:,i)'.*100);                 
end

set(p,'LineWidth',linewdt );

set(p(1),'Color',C1,'Marker','diamond','MarkerSize',8,'MarkerFaceColor',C1)
set(p(2),'Color',C2,'Marker','o','MarkerSize',8,'MarkerFaceColor',C2)
set(p(3),'Color',C3,'Marker','square','MarkerSize',8,'MarkerFaceColor',C3)
set(p(4),'Color',C4,'Marker','^','MarkerSize',8,'MarkerFaceColor',C4)
set(p(5),'Color',C5,'Marker','x','MarkerSize',10,'MarkerFaceColor',C5)  


xlabel('Frailty quintile')       
ylabel('Share of total profits (%)')

%legend(p,{'PE quintile 1','PE quintile 2','PE quintile 3','PE quintile 4','PE quintile 5'},'Position',[0.38,0.06, 1, 1],'units','normalized');
legend(p,{'PE quintile 1','PE quintile 2','PE quintile 3','PE quintile 4','PE quintile 5'},'location','NorthWest','orientation','vertical');
legend boxoff

set(gcf,'PaperPositionMode','auto');
set(gcf,'PaperUnits','inches')
set(gcf,'PaperSize',[8.1,6])
set(gcf,'PaperPosition',[0.0,0.0,8,6])
set(gca,'LooseInset',get(gca,'TightInset'))
print(gcf,'-dpdf','ProfitsSharesNoMedicaid.pdf')
%%

%% figure indementies by frailty in 3 economies
figure
axes('FontSize',fSize,'FontName',fName,...
     'XTick',FrailtyTick,...
     'XGrid','off','YGrid','off');
box off
hold on;

p(1)=plot(FracCoveredl_byhq_means_1);        
p(2)=plot(FracCoveredl_byhq_means_2);        
p(3)=plot(FracCoveredl_byhq_means_3);        
p(4)=plot(FracCoveredh_byhq_means_1,'--');        
p(5)=plot(FracCoveredh_byhq_means_2,'--');        
p(6)=plot(FracCoveredh_byhq_means_3,'--'); 

set(p,'LineWidth',linewdt );

set(p(1),'Color',C1,'Marker','diamond','MarkerSize',8,'MarkerFaceColor',C1)
set(p(2),'Color',C2,'Marker','o','MarkerSize',8,'MarkerFaceColor',C2)
set(p(3),'Color',C3,'Marker','square','MarkerSize',8,'MarkerFaceColor',C3)
set(p(4),'Color',C1,'Marker','diamond','MarkerSize',8,'MarkerFaceColor',C1)
set(p(5),'Color',C2,'Marker','o','MarkerSize',8,'MarkerFaceColor',C2)
set(p(6),'Color',C3,'Marker','square','MarkerSize',8,'MarkerFaceColor',C3)
%set(p(4),'Color',C4,'Marker','^','MarkerSize',8,'MarkerFaceColor',C4)
%set(p(5),'Color',C5,'Marker','x','MarkerSize',10,'MarkerFaceColor',C5)  


xlabel('Frailty quintile')       
ylabel('Indemnity/NH cost')


%legend(p,{'PE quintile 1','PE quintile 2','PE quintile 3','PE quintile 4','PE quintile 5'},'location','NorthEast','orientation','vertical');
legend(p,{'Baseline','No Medicaid','Full Information'},'Position',[0.1,0.07, 0.6, 1],'units','normalized');
legend boxoff

set(gcf,'PaperPositionMode','auto');
set(gcf,'PaperUnits','inches')
set(gcf,'PaperSize',[8.1,6])
set(gcf,'PaperPosition',[0.0,0.0,8,6])
set(gca,'LooseInset',get(gca,'TightInset'))
print(gcf,'-dpdf','fig-cover-frailty.pdf')
%%

%% figure indementies by wealth in 3 economies
figure
axes('FontSize',fSize,'FontName',fName,...
     'XTick',FrailtyTick,...
     'XGrid','off','YGrid','off');
box off
hold on;

p(1)=plot(FracCoveredl_byasq_means_1);        
p(2)=plot(FracCoveredl_byasq_means_2);        
p(3)=plot(FracCoveredl_byasq_means_3);        
p(4)=plot(FracCoveredh_byasq_means_1,'--');        
p(5)=plot(FracCoveredh_byasq_means_2,'--');        
p(6)=plot(FracCoveredh_byasq_means_3,'--'); 

set(p,'LineWidth',linewdt );

set(p(1),'Color',C1,'Marker','diamond','MarkerSize',8,'MarkerFaceColor',C1)
set(p(2),'Color',C2,'Marker','o','MarkerSize',8,'MarkerFaceColor',C2)
set(p(3),'Color',C3,'Marker','square','MarkerSize',8,'MarkerFaceColor',C3)
set(p(4),'Color',C1,'Marker','diamond','MarkerSize',8,'MarkerFaceColor',C1)
set(p(5),'Color',C2,'Marker','o','MarkerSize',8,'MarkerFaceColor',C2)
set(p(6),'Color',C3,'Marker','square','MarkerSize',8,'MarkerFaceColor',C3)
%set(p(4),'Color',C4,'Marker','^','MarkerSize',8,'MarkerFaceColor',C4)
%set(p(5),'Color',C5,'Marker','x','MarkerSize',10,'MarkerFaceColor',C5)  


xlabel('Wealth quintile')       
ylabel('Indemnity/NH cost')

%legend(p,{'PE quintile 1','PE quintile 2','PE quintile 3','PE quintile 4','PE quintile 5'},'Position',[0.38,0.06, 1, 1],'units','normalized');
legend(p,{'Baseline','No Medicaid','Full Information'},'location','SouthWest','orientation','vertical');
legend boxoff

set(gcf,'PaperPositionMode','auto');
set(gcf,'PaperUnits','inches')
set(gcf,'PaperSize',[8.1,6])
set(gcf,'PaperPosition',[0.0,0.0,8,6])
set(gca,'LooseInset',get(gca,'TightInset'))
print(gcf,'-dpdf','fig-cover-wealth.pdf')
%%

%% figure indementies by PE in 3 economies
figure
axes('FontSize',fSize,'FontName',fName,...
     'XTick',FrailtyTick,...
     'XGrid','off','YGrid','off');
box off
hold on;

p(1)=plot(FracCoveredl_byyq_means_1);        
p(2)=plot(FracCoveredl_byyq_means_2);        
p(3)=plot(FracCoveredl_byyq_means_3);        
p(4)=plot(FracCoveredh_byyq_means_1,'--');        
p(5)=plot(FracCoveredh_byyq_means_2,'--');        
p(6)=plot(FracCoveredh_byyq_means_3,'--'); 

set(p,'LineWidth',linewdt );

set(p(1),'Color',C1,'Marker','diamond','MarkerSize',8,'MarkerFaceColor',C1)
set(p(2),'Color',C2,'Marker','o','MarkerSize',8,'MarkerFaceColor',C2)
set(p(3),'Color',C3,'Marker','square','MarkerSize',8,'MarkerFaceColor',C3)
set(p(4),'Color',C1,'Marker','diamond','MarkerSize',8,'MarkerFaceColor',C1)
set(p(5),'Color',C2,'Marker','o','MarkerSize',8,'MarkerFaceColor',C2)
set(p(6),'Color',C3,'Marker','square','MarkerSize',8,'MarkerFaceColor',C3)
%set(p(4),'Color',C4,'Marker','^','MarkerSize',8,'MarkerFaceColor',C4)
%set(p(5),'Color',C5,'Marker','x','MarkerSize',10,'MarkerFaceColor',C5)  


xlabel('PE quintile')       
ylabel('Indemnity/NH cost')

%legend(p,{'PE quintile 1','PE quintile 2','PE quintile 3','PE quintile 4','PE quintile 5'},'Position',[0.38,0.06, 1, 1],'units','normalized');
legend(p,{'Baseline','No Medicaid','Full Information'},'location','SouthWest','orientation','vertical');
legend boxoff

set(gcf,'PaperPositionMode','auto');
set(gcf,'PaperUnits','inches')
set(gcf,'PaperSize',[8.1,6])
set(gcf,'PaperPosition',[0.0,0.0,8,6])
set(gca,'LooseInset',get(gca,'TightInset'))
print(gcf,'-dpdf','fig-cover-PE.pdf')
%%

%% figure loads by frailty in 3 economies
figure
axes('FontSize',fSize,'FontName',fName,...
     'XTick',FrailtyTick,...
     'XGrid','off','YGrid','off');
box off
hold on;

p(1)=plot(loadl_byhq_means_1);        
p(2)=plot(loadl_byhq_means_2);        
p(3)=plot(loadl_byhq_means_3);        
p(4)=plot(loadh_byhq_means_1,'--');        
p(5)=plot(loadh_byhq_means_2,'--');        
p(6)=plot(loadh_byhq_means_3,'--'); 

set(p,'LineWidth',linewdt );

set(p(1),'Color',C1,'Marker','diamond','MarkerSize',8,'MarkerFaceColor',C1)
set(p(2),'Color',C2,'Marker','o','MarkerSize',8,'MarkerFaceColor',C2)
set(p(3),'Color',C3,'Marker','square','MarkerSize',8,'MarkerFaceColor',C3)
set(p(4),'Color',C1,'Marker','diamond','MarkerSize',8,'MarkerFaceColor',C1)
set(p(5),'Color',C2,'Marker','o','MarkerSize',8,'MarkerFaceColor',C2)
set(p(6),'Color',C3,'Marker','square','MarkerSize',8,'MarkerFaceColor',C3)
%set(p(4),'Color',C4,'Marker','^','MarkerSize',8,'MarkerFaceColor',C4)
%set(p(5),'Color',C5,'Marker','x','MarkerSize',10,'MarkerFaceColor',C5)  


xlabel('Frailty quintile')       
ylabel('Load')
ylim([-0.1 1.2])

%legend(p,{'PE quintile 1','PE quintile 2','PE quintile 3','PE quintile 4','PE quintile 5'},'Position',[0.38,0.06, 1, 1],'units','normalized');
legend(p,{'Baseline','No Medicaid','Full Information'},'location','NorthWest','orientation','vertical');
legend boxoff

set(gcf,'PaperPositionMode','auto');
set(gcf,'PaperUnits','inches')
set(gcf,'PaperSize',[8.1,6])
set(gcf,'PaperPosition',[0.0,0.0,8,6])
set(gca,'LooseInset',get(gca,'TightInset'))
print(gcf,'-dpdf','fig-load-frailty.pdf')
%%

%% figure loads by wealth in 3 economies
figure
axes('FontSize',fSize,'FontName',fName,...
     'XTick',FrailtyTick,...
     'XGrid','off','YGrid','off');
box off
hold on;

p(1)=plot(loadl_byasq_means_1);        
p(2)=plot(loadl_byasq_means_2);        
p(3)=plot(loadl_byasq_means_3);        
p(4)=plot(loadh_byasq_means_1,'--');        
p(5)=plot(loadh_byasq_means_2,'--');        
p(6)=plot(loadh_byasq_means_3,'--'); 

set(p,'LineWidth',linewdt );

set(p(1),'Color',C1,'Marker','diamond','MarkerSize',8,'MarkerFaceColor',C1)
set(p(2),'Color',C2,'Marker','o','MarkerSize',8,'MarkerFaceColor',C2)
set(p(3),'Color',C3,'Marker','square','MarkerSize',8,'MarkerFaceColor',C3)
set(p(4),'Color',C1,'Marker','diamond','MarkerSize',8,'MarkerFaceColor',C1)
set(p(5),'Color',C2,'Marker','o','MarkerSize',8,'MarkerFaceColor',C2)
set(p(6),'Color',C3,'Marker','square','MarkerSize',8,'MarkerFaceColor',C3)
%set(p(4),'Color',C4,'Marker','^','MarkerSize',8,'MarkerFaceColor',C4)
%set(p(5),'Color',C5,'Marker','x','MarkerSize',10,'MarkerFaceColor',C5)  


xlabel('Wealth quintile')       
ylabel('Load')
%legend(p,{'PE quintile 1','PE quintile 2','PE quintile 3','PE quintile 4','PE quintile 5'},'Position',[0.38,0.06, 1, 1],'units','normalized');
legend(p,{'Baseline','No Medicaid','Full Information'},'location','SouthWest','orientation','vertical');
legend boxoff

set(gcf,'PaperPositionMode','auto');
set(gcf,'PaperUnits','inches')
set(gcf,'PaperSize',[8.1,6])
set(gcf,'PaperPosition',[0.0,0.0,8,6])
set(gca,'LooseInset',get(gca,'TightInset'))
print(gcf,'-dpdf','fig-load-wealth.pdf')
%%

%% figure loads by PE in 3 economies
figure
axes('FontSize',fSize,'FontName',fName,...
     'XTick',FrailtyTick,...
     'XGrid','off','YGrid','off');
box off
hold on;

p(1)=plot(loadl_byyq_means_1);        
p(2)=plot(loadl_byyq_means_2);        
p(3)=plot(loadl_byyq_means_3);        
p(4)=plot(loadh_byyq_means_1,'--');        
p(5)=plot(loadh_byyq_means_2,'--');        
p(6)=plot(loadh_byyq_means_3,'--'); 

set(p,'LineWidth',linewdt );

set(p(1),'Color',C1,'Marker','diamond','MarkerSize',8,'MarkerFaceColor',C1)
set(p(2),'Color',C2,'Marker','o','MarkerSize',8,'MarkerFaceColor',C2)
set(p(3),'Color',C3,'Marker','square','MarkerSize',8,'MarkerFaceColor',C3)
set(p(4),'Color',C1,'Marker','diamond','MarkerSize',8,'MarkerFaceColor',C1)
set(p(5),'Color',C2,'Marker','o','MarkerSize',8,'MarkerFaceColor',C2)
set(p(6),'Color',C3,'Marker','square','MarkerSize',8,'MarkerFaceColor',C3)
%set(p(4),'Color',C4,'Marker','^','MarkerSize',8,'MarkerFaceColor',C4)
%set(p(5),'Color',C5,'Marker','x','MarkerSize',10,'MarkerFaceColor',C5)  


xlabel('PE quintile')       
ylabel('Load')
%legend(p,{'PE quintile 1','PE quintile 2','PE quintile 3','PE quintile 4','PE quintile 5'},'Position',[0.38,0.06, 1, 1],'units','normalized');
legend(p,{'Baseline','No Medicaid','Full Information'},'location','SouthWest','orientation','vertical');
legend boxoff

set(gcf,'PaperPositionMode','auto');
set(gcf,'PaperUnits','inches')
set(gcf,'PaperSize',[8.1,6])
set(gcf,'PaperPosition',[0.0,0.0,8,6])
set(gca,'LooseInset',get(gca,'TightInset'))
print(gcf,'-dpdf','fig-load-PE.pdf')
%%

%report by quintile not by grid point
[thetal_means,  thetal_shares] = get_dist_stats_x(thetalmat_2(1,:,1), disth_2, phi_cutoffs_2, ng_2)
[thetah_means,  thetah_shares] = get_dist_stats_x(thetahmat_2(1,:,1), disth_2, phi_cutoffs_2, ng_2)
 